/***************************************************************
   LF2 Data Changer is a program that a allows you to edit, LF2 data files.
    Copyright (C) 2012  Someone else

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

My email address is <adrianbibbywalther@gmail.com>.
If you need any help, contact me there, or on the LFE Forums.
 **************************************************************/

#include "AboutBox.h"

//(*InternalHeaders(AboutBox)
#include <wx/settings.h>
#include <wx/intl.h>
#include <wx/string.h>
//*)

//(*IdInit(AboutBox)
const long AboutBox::ID_PROGRAMTEXT = wxNewId();
const long AboutBox::ID_STATICLINE = wxNewId();
const long AboutBox::ID_DESCRIPTIONFIELD = wxNewId();
const long AboutBox::ID_DESCRIPTIONPANEL = wxNewId();
const long AboutBox::ID_INFORMATIONNAME = wxNewId();
const long AboutBox::ID_INFORMATIONNAMETEXT = wxNewId();
const long AboutBox::ID_INFORMATIONVERSION = wxNewId();
const long AboutBox::ID_INFORMATIONVERSIONTEXT = wxNewId();
const long AboutBox::ID_INFORMATIONAUTHOR = wxNewId();
const long AboutBox::ID_INFORMATIONAUTHORTEXT = wxNewId();
const long AboutBox::ID_INFORMATIONPANEL = wxNewId();
const long AboutBox::ID_CREDITSFIELD = wxNewId();
const long AboutBox::ID_CREDITSPANEL = wxNewId();
const long AboutBox::ID_LICENSEFIELD = wxNewId();
const long AboutBox::ID_LicenseButton = wxNewId();
const long AboutBox::ID_LICENSEPANEL = wxNewId();
const long AboutBox::ID_ABOUTBOOK = wxNewId();
//*)

BEGIN_EVENT_TABLE(AboutBox,wxDialog)
    //(*EventTable(AboutBox)
    //*)
END_EVENT_TABLE()

AboutBox::AboutBox(wxWindow* parent,wxWindowID id,const wxPoint& pos,const wxSize& size)
{
    //(*Initialize(AboutBox)
    wxBoxSizer* DescriptionSizer;
    wxFlexGridSizer* InformationSizer;
    wxBoxSizer* CreditsSizer;
    wxBoxSizer* LicenseSizer;

    Create(parent, wxID_ANY, _("About LF2 Data Changer"), wxDefaultPosition, wxDefaultSize, wxCAPTION|wxSYSTEM_MENU|wxRESIZE_BORDER|wxCLOSE_BOX, _T("wxID_ANY"));
    Sizer = new wxBoxSizer(wxVERTICAL);
    ProgramText = new wxStaticText(this, ID_PROGRAMTEXT, _("LF2 Data Changer v1.1.2\nBy Someone else"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_PROGRAMTEXT"));
    Sizer->Add(ProgramText, 0, wxTOP|wxLEFT|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    StaticLine = new wxStaticLine(this, ID_STATICLINE, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL, _T("ID_STATICLINE"));
    Sizer->Add(StaticLine, 0, wxBOTTOM|wxLEFT|wxRIGHT|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 2);
    AboutBook = new wxNotebook(this, ID_ABOUTBOOK, wxDefaultPosition, wxDefaultSize, 0, _T("ID_ABOUTBOOK"));
    AboutBook->SetMinSize(wxSize(400,120));
    DescriptionPanel = new wxPanel(AboutBook, ID_DESCRIPTIONPANEL, wxPoint(29,12), wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_DESCRIPTIONPANEL"));
    DescriptionPanel->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOW));
    DescriptionSizer = new wxBoxSizer(wxHORIZONTAL);
    DescriptionField = new wxTextCtrl(DescriptionPanel, ID_DESCRIPTIONFIELD, _("This program is a Little Fighter 2 data changer, which is a program you use to edit LF2 datafiles, in order to create your own characters weapons etc.\nIf you want to learn more about data changing, then visit Little Fighter Empire:\nhttp://lf-empire.de"), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY|wxTE_LEFT|wxTE_WORDWRAP|wxNO_BORDER, wxDefaultValidator, _T("ID_DESCRIPTIONFIELD"));
    DescriptionSizer->Add(DescriptionField, 1, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    DescriptionPanel->SetSizer(DescriptionSizer);
    DescriptionSizer->Fit(DescriptionPanel);
    DescriptionSizer->SetSizeHints(DescriptionPanel);
    InformationPanel = new wxPanel(AboutBook, ID_INFORMATIONPANEL, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_INFORMATIONPANEL"));
    InformationSizer = new wxFlexGridSizer(0, 2, 0, 0);
    InformationName = new wxStaticText(InformationPanel, ID_INFORMATIONNAME, _("Name:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_INFORMATIONNAME"));
    InformationSizer->Add(InformationName, 1, wxALL|wxALIGN_LEFT|wxALIGN_TOP, 5);
    InformationNameText = new wxStaticText(InformationPanel, ID_INFORMATIONNAMETEXT, _("LF2 Data Changer"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_INFORMATIONNAMETEXT"));
    InformationSizer->Add(InformationNameText, 1, wxTOP|wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_TOP, 5);
    InformationVersion = new wxStaticText(InformationPanel, ID_INFORMATIONVERSION, _("Version:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_INFORMATIONVERSION"));
    InformationSizer->Add(InformationVersion, 1, wxBOTTOM|wxLEFT|wxRIGHT|wxALIGN_LEFT|wxALIGN_TOP, 5);
    InformationVersionText = new wxStaticText(InformationPanel, ID_INFORMATIONVERSIONTEXT, _("1.1.2"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_INFORMATIONVERSIONTEXT"));
    InformationSizer->Add(InformationVersionText, 1, wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_TOP, 5);
    InformationAuthor = new wxStaticText(InformationPanel, ID_INFORMATIONAUTHOR, _("Author:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_INFORMATIONAUTHOR"));
    InformationSizer->Add(InformationAuthor, 1, wxBOTTOM|wxLEFT|wxRIGHT|wxALIGN_LEFT|wxALIGN_TOP, 5);
    InformationAuthorText = new wxStaticText(InformationPanel, ID_INFORMATIONAUTHORTEXT, _("Someone else"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_INFORMATIONAUTHORTEXT"));
    InformationSizer->Add(InformationAuthorText, 1, wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_TOP, 5);
    InformationPanel->SetSizer(InformationSizer);
    InformationSizer->Fit(InformationPanel);
    InformationSizer->SetSizeHints(InformationPanel);
    CreditsPanel = new wxPanel(AboutBook, ID_CREDITSPANEL, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_CREDITSPANEL"));
    CreditsPanel->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOW));
    CreditsSizer = new wxBoxSizer(wxHORIZONTAL);
    CreditsField = new wxTextCtrl(CreditsPanel, ID_CREDITSFIELD, _("The following libraries are used in this program:\n -wxWidgets, by Julian Smart and the rest of The wxWidgets Team.\n  Used for the GUI interface.\n -wxStc, which is based on Scintilla, by Neil Hodgson.\n  Used for the syntax highlighter.\n -TinyXML, by Lee Thomason\n  Used for reading and writing the configuration file.\n\nNote: The LF2DC and LF2AI lexers were written by me, and a few other changes has been made to wxStc.\n"), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY|wxTE_AUTO_URL|wxTE_LEFT|wxTE_WORDWRAP|wxNO_BORDER, wxDefaultValidator, _T("ID_CREDITSFIELD"));
    CreditsSizer->Add(CreditsField, 1, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    CreditsPanel->SetSizer(CreditsSizer);
    CreditsSizer->Fit(CreditsPanel);
    CreditsSizer->SetSizeHints(CreditsPanel);
    LicensePanel = new wxPanel(AboutBook, ID_LICENSEPANEL, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_LICENSEPANEL"));
    LicensePanel->SetBackgroundColour(wxSystemSettings::GetColour(wxSYS_COLOUR_WINDOW));
    LicenseSizer = new wxBoxSizer(wxVERTICAL);
    LicenseField = new wxTextCtrl(LicensePanel, ID_LICENSEFIELD, _("This program is licensed under the terms of the GNU General Public License version 3."), wxDefaultPosition, wxDefaultSize, wxTE_MULTILINE|wxTE_READONLY|wxTE_AUTO_URL|wxTE_LEFT|wxTE_WORDWRAP|wxNO_BORDER, wxDefaultValidator, _T("ID_LICENSEFIELD"));
    LicenseSizer->Add(LicenseField, 1, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    LicenseButton = new wxButton(LicensePanel, ID_LicenseButton, _("Show License"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_LicenseButton"));
    LicenseSizer->Add(LicenseButton, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    LicensePanel->SetSizer(LicenseSizer);
    LicenseSizer->Fit(LicensePanel);
    LicenseSizer->SetSizeHints(LicensePanel);
    AboutBook->AddPage(DescriptionPanel, _("Description"), true);
    AboutBook->AddPage(InformationPanel, _("Information"), false);
    AboutBook->AddPage(CreditsPanel, _("Credits"), false);
    AboutBook->AddPage(LicensePanel, _("License"), false);
    Sizer->Add(AboutBook, 1, wxBOTTOM|wxLEFT|wxRIGHT|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    SetSizer(Sizer);
    Sizer->Fit(this);
    Sizer->SetSizeHints(this);

    Connect(ID_LicenseButton,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&AboutBox::OnShowLicense);
    //*)

    LicenseDlg = new LicenseBox(0);
}

AboutBox::~AboutBox()
{
    //(*Destroy(AboutBox)
    //*)
}

bool AboutBox::Destroy(){
    LicenseDlg->Destroy();
    return wxDialog::Destroy();
}

void AboutBox::OnShowLicense(wxCommandEvent& event){
    LicenseDlg->ShowModal();
}
