/***************************************************************
   LF2 Data Changer is a program that a allows you to edit, LF2 data files.
    Copyright (C) 2012  Someone else

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

My email address is <adrianbibbywalther@gmail.com>.
If you need any help, contact me there, or on the LFE Forums.
 **************************************************************/

#ifndef ABOUTBOX_H
#define ABOUTBOX_H

#include "LicenseBox.h"

//(*Headers(AboutBox)
#include <wx/notebook.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/statline.h>
#include <wx/panel.h>
#include <wx/button.h>
#include <wx/dialog.h>
//*)

class AboutBox: public wxDialog
{
	public:

		AboutBox(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~AboutBox();

		//(*Declarations(AboutBox)
		wxStaticText* InformationName;
		wxPanel* DescriptionPanel;
		wxStaticLine* StaticLine;
		wxStaticText* ProgramText;
		wxBoxSizer* Sizer;
		wxTextCtrl* LicenseField;
		wxStaticText* InformationVersion;
		wxPanel* LicensePanel;
		wxStaticText* InformationAuthor;
		wxButton* LicenseButton;
		wxStaticText* InformationNameText;
		wxStaticText* InformationAuthorText;
		wxPanel* InformationPanel;
		wxNotebook* AboutBook;
		wxPanel* CreditsPanel;
		wxTextCtrl* DescriptionField;
		wxTextCtrl* CreditsField;
		wxStaticText* InformationVersionText;
		//*)

        bool Destroy();

	protected:

		//(*Identifiers(AboutBox)
		static const long ID_PROGRAMTEXT;
		static const long ID_STATICLINE;
		static const long ID_DESCRIPTIONFIELD;
		static const long ID_DESCRIPTIONPANEL;
		static const long ID_INFORMATIONNAME;
		static const long ID_INFORMATIONNAMETEXT;
		static const long ID_INFORMATIONVERSION;
		static const long ID_INFORMATIONVERSIONTEXT;
		static const long ID_INFORMATIONAUTHOR;
		static const long ID_INFORMATIONAUTHORTEXT;
		static const long ID_INFORMATIONPANEL;
		static const long ID_CREDITSFIELD;
		static const long ID_CREDITSPANEL;
		static const long ID_LICENSEFIELD;
		static const long ID_LicenseButton;
		static const long ID_LICENSEPANEL;
		static const long ID_ABOUTBOOK;
		//*)

	private:

		//(*Handlers(AboutBox)
		void OnShowLicense(wxCommandEvent& event);
		//*)

        LicenseBox *LicenseDlg;

		DECLARE_EVENT_TABLE()
};

#endif
