/***************************************************************
   LF2 Data Changer is a program that a allows you to edit, LF2 data files.
    Copyright (C) 2012  Someone else

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

My email address is <adrianbibbywalther@gmail.com>.
If you need any help, contact me there, or on the LFE Forums.
 **************************************************************/

#ifndef EDITORPANEL_H
#define EDITORPANEL_H

#include <sstream>
#include "contrib/include/wx/stc/stc.h"

//(*Headers(EditorPanel)
#include <wx/sizer.h>
#include <wx/panel.h>
//*)

class LF2DataChangerFrame;

class EditorPanel: public wxPanel {
    friend class LF2DataChangerFrame;

    public:
        EditorPanel(wxWindow* parent,wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
        virtual ~EditorPanel();

        //(*Declarations(EditorPanel)
        wxPanel* PanelEditor;
        wxPanel* PanelBuilder;
        //*)

        wxStyledTextCtrl* Editor;
        wxString &GetFilename();

        #ifdef USE_WRITETOEXE
            int Pid;
            int Id;
            int Type;
            char *Addr;
        #endif

        void HighlightBraces();

    protected:

        //(*Identifiers(EditorPanel)
        static const long ID_PANELEDITOR;
        static const long ID_PANELBUILDER;
        //*)
        static const long ID_EDITOR;

    private:

        //(*Handlers(EditorPanel)
        void OnMarginClick(wxStyledTextEvent& event);
        void OnCharAdded(wxStyledTextEvent& event);
        void OnChange(wxStyledTextEvent& event);
        void OnZoom(wxStyledTextEvent& event);
        void OnEditorUpdateUI(wxStyledTextEvent& event);
        //*)
        void StyleEditor();
        void UpdateLexer(int Lexer);

        LF2DataChangerFrame *Frame;
        wxString Filename;
        bool Saved;

        wxFont EditorDEFAULTFont;
        wxFont EditorBOLDFont;
        wxFont EditorBIGFont;

        DECLARE_EVENT_TABLE()
};

#endif
