/***************************************************************
   LF2 Data Changer is a program that a allows you to edit, LF2 data files.
    Copyright (C) 2012  Someone else

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

My email address is <adrianbibbywalther@gmail.com>.
If you need any help, contact me there, or on the LFE Forums.
 **************************************************************/

#include "LF2DataChangerApp.h"
#include "DDE.h"

//(*AppHeaders
#include "LF2DataChangerMain.h"
#include <wx/image.h>
//*)

wxCmdLineParser *LF2DataChangerApp::CmdParser;

IMPLEMENT_APP(LF2DataChangerApp);

bool LF2DataChangerApp::OnInit()
{
    wxCmdLineEntryDesc CmdDescription[] = {{wxCMD_LINE_PARAM,
                                            NULL,
                                            NULL,
                                            _("input files"),
                                            wxCMD_LINE_VAL_STRING,
                                            wxCMD_LINE_PARAM_OPTIONAL|wxCMD_LINE_PARAM_MULTIPLE},{
                                            wxCMD_LINE_NONE}};

    CmdParser = new wxCmdLineParser(CmdDescription,argc,argv);
    CmdParser->Parse();

    DDEClient Client;

    wxLogNull LogNuller;

    #ifdef __WXMSW__
        DDEConnection *Connection = static_cast<DDEConnection*>(Client.MakeConnection(_T("localhost"),_T("LF2DC"),_T("LF2DCDDEOpen")));
    #else
        DDEConnection *Connection = static_cast<DDEConnection*>(Client.MakeConnection(_T("localhost"),wxString::Format(_T("/tmp/LF2DC%s.socket"),wxGetUserId().wx_str(),_T("LF2DCDDEOpen"))));
    #endif

    if(Connection){
        for(unsigned int i = 0;i<CmdParser->GetParamCount();++i){
            Connection->Execute(CmdParser->GetParam(i));
        }

        delete Connection;

        return false;//do not start the program
    }

    //(*AppInitialize
    bool wxsOK = true;
    wxInitAllImageHandlers();
    if ( wxsOK )
    {
    	LF2DataChangerFrame* Frame = new LF2DataChangerFrame(0);
    	Frame->Show();
    	SetTopWindow(Frame);
    }
    //*)
    return wxsOK;
}
