/***************************************************************
   LF2 Data Changer is a program that a allows you to edit, LF2 data files.
    Copyright (C) 2012  Someone else

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

My email address is <adrianbibbywalther@gmail.com>.
If you need any help, contact me there, or on the LFE Forums.
 **************************************************************/

#include "LF2DataChangerMain.h"
#include "LF2DataChangerApp.h"

#include <wx/dir.h>
#include <wx/msgdlg.h>
#include <wx/stdpaths.h>
#include "contrib/include/wx/stc/stc.h"

#include "xpms/writetoexe.xpm"
#include "xpms/autowrite.xpm"

#ifdef USE_WRITETOEXE
    #include "fgetword.h"
#endif

//(*InternalHeaders(LF2DataChangerFrame)
#include <wx/artprov.h>
#include <wx/bitmap.h>
#include <wx/intl.h>
#include <wx/image.h>
#include <wx/string.h>
//*)

#ifdef USE_WRITETOEXE
    #include <psapi.h>
    #include <tlhelp32.h>
    #include "sGame.h"
#endif

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(LF2DataChangerFrame)
const long LF2DataChangerFrame::ID_AUITOOLBARFILENEW = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARFILEOPEN = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARFILESAVE = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARFILESAVEAS = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARFILECLOSE = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARFILE = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDITUNDO = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDITREDO = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDITCUT = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDITCOPY = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDITPASTE = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDITSEARCH = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDITREPLACE = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBAREDIT = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGSEARCHFIELD = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGSEARCHBUTTON = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGSEARCHREPLACE = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGREPLACEBUTTON = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGREPLACEALLBUTTON = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGWHOLEWORD = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGUP = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGMATCHCASE = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOGDOWN = wxNewId();
const long LF2DataChangerFrame::ID_SEARCHDIALOG = wxNewId();
const long LF2DataChangerFrame::ID_AUINOTEBOOK = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARSEARCHFIELD = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARSEARCHREPLACE = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARSEARCH = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARWRITEWRITE = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARWRITEAUTO = wxNewId();
const long LF2DataChangerFrame::ID_AUITOOLBARWRITE = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILENEW = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILETEMPLATEEMPTY = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILETEMPLATE = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILEOPEN = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILERECENTEMPTY = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILERECENT = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILESAVE = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILESAVEAS = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILECLOSE = wxNewId();
const long LF2DataChangerFrame::ID_MENUFILEQUIT = wxNewId();
const long LF2DataChangerFrame::ID_MENUEDITUNDO = wxNewId();
const long LF2DataChangerFrame::ID_MENUEDITREDO = wxNewId();
const long LF2DataChangerFrame::ID_MENUEDITCUT = wxNewId();
const long LF2DataChangerFrame::ID_MENUEDITCOPY = wxNewId();
const long LF2DataChangerFrame::ID_MENUEDITPASTE = wxNewId();
const long LF2DataChangerFrame::ID_MENUEDITSEARCH = wxNewId();
const long LF2DataChangerFrame::ID_MENUEDITREPLACE = wxNewId();
const long LF2DataChangerFrame::ID_MENUVIEWFILE = wxNewId();
const long LF2DataChangerFrame::ID_MENUVIEWEDIT = wxNewId();
const long LF2DataChangerFrame::ID_MENUVIEWWRITE = wxNewId();
const long LF2DataChangerFrame::ID_MENUVIEWSEARCH = wxNewId();
const long LF2DataChangerFrame::ID_MENUWRITEWRITE = wxNewId();
const long LF2DataChangerFrame::ID_MENUWRITECHOOSEEMPTY = wxNewId();
const long LF2DataChangerFrame::ID_MENUWRITECHOOSE = wxNewId();
const long LF2DataChangerFrame::ID_MENUWRITEAUTO = wxNewId();
const long LF2DataChangerFrame::ID_MENUHELPABOUT = wxNewId();
const long LF2DataChangerFrame::ID_STATUSBAR = wxNewId();
const long LF2DataChangerFrame::ID_TABSAVE = wxNewId();
const long LF2DataChangerFrame::ID_TABSAVEAS = wxNewId();
const long LF2DataChangerFrame::ID_TABCLOSE = wxNewId();
//*)

BEGIN_EVENT_TABLE(LF2DataChangerFrame,wxFrame)
    //(*EventTable(LF2DataChangerFrame)
    //*)
END_EVENT_TABLE()

#ifdef USE_WRITETOEXE
    wchar_t LF2DataChangerFrame::CurrentFilename[MAX_PATH];
#endif

LF2DataChangerFrame::LF2DataChangerFrame(wxWindow* parent,wxWindowID id)
    {
    //(*Initialize(LF2DataChangerFrame)
    wxFlexGridSizer* SearchDialogGrid;
    wxMenuBar* MenuBar;

    Create(parent, wxID_ANY, _("LF2 Data Changer"), wxDefaultPosition, wxDefaultSize, wxCAPTION|wxSYSTEM_MENU|wxRESIZE_BORDER|wxCLOSE_BOX|wxMAXIMIZE_BOX|wxMINIMIZE_BOX, _T("wxID_ANY"));
    SetClientSize(wxSize(800,480));
    AuiManager = new wxAuiManager(this, wxAUI_MGR_ALLOW_FLOATING|wxAUI_MGR_ALLOW_ACTIVE_PANE|wxAUI_MGR_TRANSPARENT_DRAG|wxAUI_MGR_TRANSPARENT_HINT|wxAUI_MGR_VENETIAN_BLINDS_HINT|wxAUI_MGR_RECTANGLE_HINT|wxAUI_MGR_HINT_FADE);
    AuiToolBarFile = new wxAuiToolBar(this, ID_AUITOOLBARFILE, wxDefaultPosition, wxDefaultSize, wxAUI_TB_OVERFLOW|wxAUI_TB_HORZ_LAYOUT|wxTAB_TRAVERSAL);
    AuiToolBarFile->AddTool(ID_AUITOOLBARFILENEW, _("New"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_NEW")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarFile->SetToolDropDown(ID_AUITOOLBARFILENEW, true);
    AuiToolBarFile->AddTool(ID_AUITOOLBARFILEOPEN, _("Open"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_OPEN")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarFile->SetToolDropDown(ID_AUITOOLBARFILEOPEN, true);
    AuiToolBarFile->AddTool(ID_AUITOOLBARFILESAVE, _("Save"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_SAVE")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVE, false);
    AuiToolBarFile->AddTool(ID_AUITOOLBARFILESAVEAS, _("Save as"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_SAVE_AS")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVEAS, false);
    AuiToolBarFile->AddTool(ID_AUITOOLBARFILECLOSE, _("Close"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_DELETE")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarFile->EnableTool(ID_AUITOOLBARFILECLOSE, false);
    AuiToolBarFile->Realize();
    AuiManager->AddPane(AuiToolBarFile, wxAuiPaneInfo().Name(_T("ToolbarFile")).ToolbarPane().DefaultPane().Layer(10).Top().DockFixed().BottomDockable(false).LeftDockable(false).RightDockable(false).Floatable(false).Gripper());
    AuiToolBarEdit = new wxAuiToolBar(this, ID_AUITOOLBAREDIT, wxDefaultPosition, wxDefaultSize, wxAUI_TB_OVERFLOW|wxAUI_TB_HORZ_LAYOUT|wxTAB_TRAVERSAL);
    AuiToolBarEdit->AddTool(ID_AUITOOLBAREDITUNDO, _("Undo"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_UNDO")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITUNDO, false);
    AuiToolBarEdit->AddTool(ID_AUITOOLBAREDITREDO, _("Redo"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_REDO")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITREDO, false);
    AuiToolBarEdit->AddSeparator();
    AuiToolBarEdit->AddTool(ID_AUITOOLBAREDITCUT, _("Cut"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_CUT")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITCUT, false);
    AuiToolBarEdit->AddTool(ID_AUITOOLBAREDITCOPY, _("Copy"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_COPY")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITCOPY, false);
    AuiToolBarEdit->AddTool(ID_AUITOOLBAREDITPASTE, _("Paste"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_PASTE")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITPASTE, false);
    AuiToolBarEdit->AddSeparator();
    AuiToolBarEdit->AddTool(ID_AUITOOLBAREDITSEARCH, _("Search"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FIND")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITSEARCH, false);
    AuiToolBarEdit->AddTool(ID_AUITOOLBAREDITREPLACE, _("Replace"), wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FIND_AND_REPLACE")),wxART_TOOLBAR), wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITREPLACE, false);
    AuiToolBarEdit->Realize();
    AuiManager->AddPane(AuiToolBarEdit, wxAuiPaneInfo().Name(_T("ToolbarEdit")).ToolbarPane().DefaultPane().Layer(10).Top().DockFixed().BottomDockable(false).LeftDockable(false).RightDockable(false).Floatable(false).Gripper());
    SearchDialog = new wxPanel(this, ID_SEARCHDIALOG, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL, _T("ID_SEARCHDIALOG"));
    SearchDialog->SetMinSize(wxSize(220,200));
    SearchDialogGrid = new wxFlexGridSizer(0, 2, 0, 0);
    SearchDialogGrid->AddGrowableCol(0);
    SearchDialogSearchField = new wxTextCtrl(SearchDialog, ID_SEARCHDIALOGSEARCHFIELD, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_PROCESS_ENTER, wxDefaultValidator, _T("ID_SEARCHDIALOGSEARCHFIELD"));
    SearchDialogGrid->Add(SearchDialogSearchField, 0, wxALL|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogSearchButton = new wxButton(SearchDialog, ID_SEARCHDIALOGSEARCHBUTTON, _("Search"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_SEARCHDIALOGSEARCHBUTTON"));
    SearchDialogGrid->Add(SearchDialogSearchButton, 1, wxTOP|wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogSearchReplace = new wxTextCtrl(SearchDialog, ID_SEARCHDIALOGSEARCHREPLACE, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxTE_PROCESS_ENTER, wxDefaultValidator, _T("ID_SEARCHDIALOGSEARCHREPLACE"));
    SearchDialogGrid->Add(SearchDialogSearchReplace, 1, wxBOTTOM|wxLEFT|wxRIGHT|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogReplaceButton = new wxButton(SearchDialog, ID_SEARCHDIALOGREPLACEBUTTON, _("Replace"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_SEARCHDIALOGREPLACEBUTTON"));
    SearchDialogGrid->Add(SearchDialogReplaceButton, 1, wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogGrid->Add(0,0,1, wxBOTTOM|wxLEFT|wxRIGHT|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogReplaceAllButton = new wxButton(SearchDialog, ID_SEARCHDIALOGREPLACEALLBUTTON, _("Replace All"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_SEARCHDIALOGREPLACEALLBUTTON"));
    SearchDialogGrid->Add(SearchDialogReplaceAllButton, 1, wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogWholeWord = new wxCheckBox(SearchDialog, ID_SEARCHDIALOGWHOLEWORD, _("Whole word"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_SEARCHDIALOGWHOLEWORD"));
    SearchDialogWholeWord->SetValue(false);
    SearchDialogGrid->Add(SearchDialogWholeWord, 1, wxBOTTOM|wxLEFT|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogUp = new wxRadioButton(SearchDialog, ID_SEARCHDIALOGUP, _("Up"), wxDefaultPosition, wxDefaultSize, wxRB_GROUP, wxDefaultValidator, _T("ID_SEARCHDIALOGUP"));
    SearchDialogGrid->Add(SearchDialogUp, 1, wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogMatchCase = new wxCheckBox(SearchDialog, ID_SEARCHDIALOGMATCHCASE, _("Match case"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_SEARCHDIALOGMATCHCASE"));
    SearchDialogMatchCase->SetValue(false);
    SearchDialogGrid->Add(SearchDialogMatchCase, 1, wxBOTTOM|wxLEFT|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialogDown = new wxRadioButton(SearchDialog, ID_SEARCHDIALOGDOWN, _("Down"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_SEARCHDIALOGDOWN"));
    SearchDialogDown->SetValue(true);
    SearchDialogGrid->Add(SearchDialogDown, 1, wxBOTTOM|wxRIGHT|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
    SearchDialog->SetSizer(SearchDialogGrid);
    SearchDialogGrid->Fit(SearchDialog);
    SearchDialogGrid->SetSizeHints(SearchDialog);
    AuiManager->AddPane(SearchDialog, wxAuiPaneInfo().Name(_T("SearchDialog")).DefaultPane().Caption(_("Search")).Float().Left().TopDockable(false).BottomDockable(false).FloatingSize(wxSize(400,300)).MinSize(wxSize(220,200)).Hide());
    AuiNotebook = new wxAuiNotebook(this, ID_AUINOTEBOOK, wxDefaultPosition, wxDefaultSize, wxAUI_NB_TAB_SPLIT|wxAUI_NB_TAB_MOVE|wxAUI_NB_TAB_EXTERNAL_MOVE|wxAUI_NB_SCROLL_BUTTONS|wxAUI_NB_CLOSE_ON_ACTIVE_TAB|wxAUI_NB_TOP|wxSUNKEN_BORDER|wxTAB_TRAVERSAL);
    AuiManager->AddPane(AuiNotebook, wxAuiPaneInfo().Name(_T("Notebook")).CenterPane().DockFixed().Dockable(false).Movable(false).PaneBorder(false));
    AuiToolBarSearch = new wxAuiToolBar(this, ID_AUITOOLBARSEARCH, wxDefaultPosition, wxDefaultSize, wxNO_BORDER|wxTAB_TRAVERSAL);
    AuiToolBarSearchField = new wxSearchCtrl(AuiToolBarSearch, ID_AUITOOLBARSEARCHFIELD, wxEmptyString, wxDefaultPosition, wxSize(190,-1), wxTE_PROCESS_ENTER, wxDefaultValidator, _T("ID_AUITOOLBARSEARCHFIELD"));
    AuiToolBarSearchReplace = new wxSearchCtrl(AuiToolBarSearch, ID_AUITOOLBARSEARCHREPLACE, wxEmptyString, wxDefaultPosition, wxSize(190,-1), wxTE_PROCESS_ENTER, wxDefaultValidator, _T("ID_AUITOOLBARSEARCHREPLACE"));
    AuiToolBarSearchReplace->SetDescriptiveText(_T("Replace"));
    AuiToolBarSearch->AddControl(AuiToolBarSearchField, _("Search"));
    AuiToolBarSearch->AddSeparator();
    AuiToolBarSearch->AddControl(AuiToolBarSearchReplace, _("Replace"));
    AuiToolBarSearch->Realize();
    AuiManager->AddPane(AuiToolBarSearch, wxAuiPaneInfo().Name(_T("ToolbarSearch")).ToolbarPane().DefaultPane().Layer(10).Bottom().DockFixed().TopDockable(false).LeftDockable(false).RightDockable(false).Floatable(false).MinSize(wxSize(0,25)).MaxSize(wxSize(0,25)).Movable(false).Gripper(false).Hide());
    AuiToolBarWrite = new wxAuiToolBar(this, ID_AUITOOLBARWRITE, wxDefaultPosition, wxDefaultSize, wxAUI_TB_OVERFLOW|wxAUI_TB_HORZ_LAYOUT|wxTAB_TRAVERSAL);
    AuiToolBarWrite->AddTool(ID_AUITOOLBARWRITEWRITE, _("Write to executable"), writetoexe_xpm, wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarWrite->SetToolDropDown(ID_AUITOOLBARWRITEWRITE, true);
    AuiToolBarWrite->EnableTool(ID_AUITOOLBARWRITEWRITE, false);
    AuiToolBarWrite->AddTool(ID_AUITOOLBARWRITEAUTO, _("Auto write"), autowrite_xpm, wxNullBitmap, wxITEM_NORMAL, wxEmptyString, wxEmptyString, NULL);
    AuiToolBarWrite->Realize();
    AuiManager->AddPane(AuiToolBarWrite, wxAuiPaneInfo().Name(_T("ToolbarWrite")).ToolbarPane().DefaultPane().Layer(10).Top().DockFixed().BottomDockable(false).LeftDockable(false).RightDockable(false).Floatable(false).Gripper());
    AuiManager->Update();
    MenuBar = new wxMenuBar();
    MenuFile = new wxMenu();
    MenuFileNew = new wxMenuItem(MenuFile, ID_MENUFILENEW, _("&New"), _("Create a new empty file"), wxITEM_NORMAL);
    MenuFileNew->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_NEW")),wxART_MENU));
    MenuFile->Append(MenuFileNew);
    MenuFileTemplate = new wxMenu();
    MenuFileTemplateEmpty = new wxMenuItem(MenuFileTemplate, ID_MENUFILETEMPLATEEMPTY, _("(empty)"), _("There are no templates"), wxITEM_NORMAL);
    MenuFileTemplate->Append(MenuFileTemplateEmpty);
    MenuFileTemplateEmpty->Enable(false);
    MenuFile->Append(ID_MENUFILETEMPLATE, _("From template"), MenuFileTemplate, _("Create a new file from a template"));
    MenuFileOpen = new wxMenuItem(MenuFile, ID_MENUFILEOPEN, _("&Open\tCtrl+O"), _("Open an existing file"), wxITEM_NORMAL);
    MenuFileOpen->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_OPEN")),wxART_MENU));
    MenuFile->Append(MenuFileOpen);
    MenuFileRecent = new wxMenu();
    MenuFileRecentEmpty = new wxMenuItem(MenuFileRecent, ID_MENUFILERECENTEMPTY, _("(empty)"), _("There are no recent files"), wxITEM_NORMAL);
    MenuFileRecent->Append(MenuFileRecentEmpty);
    MenuFileRecentEmpty->Enable(false);
    MenuFile->Append(ID_MENUFILERECENT, _("Recently opened files"), MenuFileRecent, _("Open one of your recently opened files"));
    MenuFileSave = new wxMenuItem(MenuFile, ID_MENUFILESAVE, _("&Save\tCtrl+S"), _("Save your work"), wxITEM_NORMAL);
    MenuFileSave->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_SAVE")),wxART_MENU));
    MenuFile->Append(MenuFileSave);
    MenuFileSave->Enable(false);
    MenuFileSaveAs = new wxMenuItem(MenuFile, ID_MENUFILESAVEAS, _("Save as\tCtrl+Shift+S"), _("Save your work under a new filename"), wxITEM_NORMAL);
    MenuFileSaveAs->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_SAVE_AS")),wxART_MENU));
    MenuFile->Append(MenuFileSaveAs);
    MenuFileSaveAs->Enable(false);
    MenuFileClose = new wxMenuItem(MenuFile, ID_MENUFILECLOSE, _("Close\tCtrl+W"), _("Close the currently opened file"), wxITEM_NORMAL);
    MenuFileClose->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_DELETE")),wxART_MENU));
    MenuFile->Append(MenuFileClose);
    MenuFileClose->Enable(false);
    MenuFile->AppendSeparator();
    MenuFileQuit = new wxMenuItem(MenuFile, ID_MENUFILEQUIT, _("Quit\tAlt+F4"), _("Quit the program"), wxITEM_NORMAL);
    MenuFileQuit->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_QUIT")),wxART_MENU));
    MenuFile->Append(MenuFileQuit);
    MenuBar->Append(MenuFile, _("&File"));
    MenuEdit = new wxMenu();
    MenuEditUndo = new wxMenuItem(MenuEdit, ID_MENUEDITUNDO, _("&Undo\tCtrl+Z"), _("Undo you last action"), wxITEM_NORMAL);
    MenuEditUndo->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_UNDO")),wxART_MENU));
    MenuEdit->Append(MenuEditUndo);
    MenuEditUndo->Enable(false);
    MenuEditRedo = new wxMenuItem(MenuEdit, ID_MENUEDITREDO, _("&Redo\tCtrl+Y"), _("Redo your last action"), wxITEM_NORMAL);
    MenuEditRedo->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_REDO")),wxART_MENU));
    MenuEdit->Append(MenuEditRedo);
    MenuEditRedo->Enable(false);
    MenuEdit->AppendSeparator();
    MenuEditCut = new wxMenuItem(MenuEdit, ID_MENUEDITCUT, _("Cu&t\tCtrl+X"), _("Cut the selected text"), wxITEM_NORMAL);
    MenuEditCut->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_CUT")),wxART_MENU));
    MenuEdit->Append(MenuEditCut);
    MenuEditCut->Enable(false);
    MenuEditCopy = new wxMenuItem(MenuEdit, ID_MENUEDITCOPY, _("&Copy\tCtrl+C"), _("Copy the selected text"), wxITEM_NORMAL);
    MenuEditCopy->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_COPY")),wxART_MENU));
    MenuEdit->Append(MenuEditCopy);
    MenuEditCopy->Enable(false);
    MenuEditPaste = new wxMenuItem(MenuEdit, ID_MENUEDITPASTE, _("&Paste\tCtrl+V"), _("Paste the copied text"), wxITEM_NORMAL);
    MenuEditPaste->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_PASTE")),wxART_MENU));
    MenuEdit->Append(MenuEditPaste);
    MenuEditPaste->Enable(false);
    MenuEdit->AppendSeparator();
    MenuEditSearch = new wxMenuItem(MenuEdit, ID_MENUEDITSEARCH, _("&Search\tCtrl+F"), _("Search for a string"), wxITEM_NORMAL);
    MenuEditSearch->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FIND")),wxART_MENU));
    MenuEdit->Append(MenuEditSearch);
    MenuEditSearch->Enable(false);
    MenuEditReplace = new wxMenuItem(MenuEdit, ID_MENUEDITREPLACE, _("&Replace\tCtrl+R"), _("Replace a string with another string"), wxITEM_NORMAL);
    MenuEditReplace->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FIND_AND_REPLACE")),wxART_HELP_BROWSER));
    MenuEdit->Append(MenuEditReplace);
    MenuEditReplace->Enable(false);
    MenuBar->Append(MenuEdit, _("&Edit"));
    MenuView = new wxMenu();
    MenuViewFile = new wxMenuItem(MenuView, ID_MENUVIEWFILE, _("&File"), _("Show/hide the file toolbar"), wxITEM_CHECK);
    MenuView->Append(MenuViewFile);
    MenuViewEdit = new wxMenuItem(MenuView, ID_MENUVIEWEDIT, _("&Edit"), _("Show/hide the edit toolbar"), wxITEM_CHECK);
    MenuView->Append(MenuViewEdit);
    MenuViewWrite = new wxMenuItem(MenuView, ID_MENUVIEWWRITE, _("&Write To Exe"), _("Show/hide the Write To Exe toolbar"), wxITEM_CHECK);
    MenuView->Append(MenuViewWrite);
    MenuViewSearch = new wxMenuItem(MenuView, ID_MENUVIEWSEARCH, _("Sea&rch"), _("Show/hide the search toolbar"), wxITEM_CHECK);
    MenuView->Append(MenuViewSearch);
    MenuBar->Append(MenuView, _("&View"));
    MenuWrite = new wxMenu();
    MenuWriteWrite = new wxMenuItem(MenuWrite, ID_MENUWRITEWRITE, _("&Auto choose"), _("Automatically choose the executable"), wxITEM_NORMAL);
    MenuWriteWrite->SetBitmap(writetoexe_xpm);
    MenuWrite->Append(MenuWriteWrite);
    MenuWriteChoose = new wxMenu();
    MenuWriteChooseEmpty = new wxMenuItem(MenuWriteChoose, ID_MENUWRITECHOOSEEMPTY, _("(empty)"), _("There are no executables"), wxITEM_NORMAL);
    MenuWriteChoose->Append(MenuWriteChooseEmpty);
    MenuWriteChooseEmpty->Enable(false);
    MenuWrite->Append(ID_MENUWRITECHOOSE, _("Choose executeable"), MenuWriteChoose, _("Choose which executeable to write to"));
    MenuWriteAuto = new wxMenuItem(MenuWrite, ID_MENUWRITEAUTO, _("Auto &write"), _("Automatically write when saving"), wxITEM_CHECK);
    MenuWrite->Append(MenuWriteAuto);
    MenuBar->Append(MenuWrite, _("&Write To Exe"));
    MenuHelp = new wxMenu();
    MenuHelpAbout = new wxMenuItem(MenuHelp, ID_MENUHELPABOUT, _("About\tF1"), _("About this program"), wxITEM_NORMAL);
    MenuHelpAbout->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_HELP_BOOK")),wxART_OTHER));
    MenuHelp->Append(MenuHelpAbout);
    MenuBar->Append(MenuHelp, _("&Help"));
    SetMenuBar(MenuBar);
    StatusBar = new wxStatusBar(this, ID_STATUSBAR, wxST_SIZEGRIP, _T("ID_STATUSBAR"));
    int __wxStatusBarWidths_1[7] = { 240, 100, 60, 60, 60, 60, 400 };
    int __wxStatusBarStyles_1[7] = { wxSB_NORMAL, wxSB_NORMAL, wxSB_NORMAL, wxSB_NORMAL, wxSB_NORMAL, wxSB_NORMAL, wxSB_NORMAL };
    StatusBar->SetFieldsCount(7,__wxStatusBarWidths_1);
    StatusBar->SetStatusStyles(7,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar);
    OpenFileDlg = new wxFileDialog(this, _("Open data file"), wxEmptyString, wxEmptyString, _("LF2 releated files(*.dat;*.as;*.txt)|*.dat;*.as;*.txt|LF2 data files (*.dat)|*.dat|AngelScript files (*.as)|*.as|Text files (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_OPEN|wxFD_FILE_MUST_EXIST|wxFD_MULTIPLE, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
    SaveFileDlg = new wxFileDialog(this, _("Save data file"), wxEmptyString, wxEmptyString, _("LF2 releated files(*.dat;*.as;*.txt)|*.dat;*.as;*.txt|LF2 data files (*.dat)|*.dat|AngelScript files (*.as)|*.as|Text files (*.txt)|*.txt|All files (*.*)|*.*"), wxFD_SAVE|wxFD_OVERWRITE_PROMPT, wxDefaultPosition, wxDefaultSize, _T("wxFileDialog"));
    TabSave = new wxMenuItem((&TabMenu), ID_TABSAVE, _("&Save\tCtrl+S"), _("Save the file"), wxITEM_NORMAL);
    TabSave->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_SAVE")),wxART_MENU));
    TabMenu.Append(TabSave);
    TabSave->Enable(false);
    TabSaveAs = new wxMenuItem((&TabMenu), ID_TABSAVEAS, _("Save As\tCtrl+Shift+S"), _("Save your work under a new filename"), wxITEM_NORMAL);
    TabSaveAs->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_FILE_SAVE_AS")),wxART_MENU));
    TabMenu.Append(TabSaveAs);
    TabClose = new wxMenuItem((&TabMenu), ID_TABCLOSE, _("Close\tCtrl+W"), _("Close the selected file"), wxITEM_NORMAL);
    TabClose->SetBitmap(wxArtProvider::GetBitmap(wxART_MAKE_ART_ID_FROM_STR(_T("wxART_DELETE")),wxART_MENU));
    TabMenu.Append(TabClose);

    Connect(ID_AUITOOLBARFILENEW,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnNew);
    Connect(ID_AUITOOLBARFILEOPEN,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnOpen);
    Connect(ID_AUITOOLBARFILESAVE,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnSave);
    Connect(ID_AUITOOLBARFILESAVEAS,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnSaveAs);
    Connect(ID_AUITOOLBARFILECLOSE,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnCloseCurrentTab);
    Connect(ID_AUITOOLBAREDITUNDO,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnUndo);
    Connect(ID_AUITOOLBAREDITREDO,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnRedo);
    Connect(ID_AUITOOLBAREDITCUT,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnCut);
    Connect(ID_AUITOOLBAREDITCOPY,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnCopy);
    Connect(ID_AUITOOLBAREDITPASTE,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnPaste);
    Connect(ID_AUITOOLBAREDITSEARCH,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnToolSearch);
    Connect(ID_AUITOOLBAREDITREPLACE,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnToolReplace);
    Connect(ID_SEARCHDIALOGSEARCHFIELD,wxEVT_COMMAND_TEXT_ENTER,(wxObjectEventFunction)&LF2DataChangerFrame::OnSearch);
    Connect(ID_SEARCHDIALOGSEARCHBUTTON,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnSearch);
    Connect(ID_SEARCHDIALOGSEARCHREPLACE,wxEVT_COMMAND_TEXT_ENTER,(wxObjectEventFunction)&LF2DataChangerFrame::OnReplace);
    Connect(ID_SEARCHDIALOGREPLACEBUTTON,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnReplace);
    Connect(ID_SEARCHDIALOGREPLACEALLBUTTON,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnReplaceAll);
    Connect(ID_AUINOTEBOOK,wxEVT_COMMAND_AUINOTEBOOK_PAGE_CLOSE,(wxObjectEventFunction)&LF2DataChangerFrame::OnPageClose);
    Connect(ID_AUINOTEBOOK,wxEVT_COMMAND_AUINOTEBOOK_PAGE_CLOSED,(wxObjectEventFunction)&LF2DataChangerFrame::OnPageClosed);
    Connect(ID_AUINOTEBOOK,wxEVT_COMMAND_AUINOTEBOOK_PAGE_CHANGED,(wxObjectEventFunction)&LF2DataChangerFrame::OnPageChanged);
    Connect(ID_AUINOTEBOOK,wxEVT_COMMAND_AUINOTEBOOK_TAB_MIDDLE_UP,(wxObjectEventFunction)&LF2DataChangerFrame::OnTabMiddleUp);
    Connect(ID_AUINOTEBOOK,wxEVT_COMMAND_AUINOTEBOOK_TAB_RIGHT_UP,(wxObjectEventFunction)&LF2DataChangerFrame::OnTabRightUp);
    Connect(ID_AUINOTEBOOK,wxEVT_COMMAND_AUINOTEBOOK_BG_DCLICK,(wxObjectEventFunction)&LF2DataChangerFrame::OnBgDClick);
    Connect(ID_AUITOOLBARSEARCHFIELD,wxEVT_COMMAND_TEXT_ENTER,(wxObjectEventFunction)&LF2DataChangerFrame::OnSearch);
    Connect(ID_AUITOOLBARSEARCHFIELD,wxEVT_COMMAND_SEARCHCTRL_SEARCH_BTN,(wxObjectEventFunction)&LF2DataChangerFrame::OnSearch);
    Connect(ID_AUITOOLBARSEARCHREPLACE,wxEVT_COMMAND_TEXT_ENTER,(wxObjectEventFunction)&LF2DataChangerFrame::OnReplace);
    Connect(ID_AUITOOLBARSEARCHREPLACE,wxEVT_COMMAND_SEARCHCTRL_SEARCH_BTN,(wxObjectEventFunction)&LF2DataChangerFrame::OnReplace);
    Connect(ID_AUITOOLBARWRITEWRITE,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnWriteToExe);
    Connect(ID_AUITOOLBARWRITEAUTO,wxEVT_COMMAND_TOOL_CLICKED,(wxObjectEventFunction)&LF2DataChangerFrame::OnAutoWrite);
    AuiManager->Connect(wxEVT_AUI_PANE_CLOSE,(wxObjectEventFunction)&LF2DataChangerFrame::OnPaneClose,0,this);
    Connect(ID_MENUFILEOPEN,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnOpenFile);
    Connect(ID_MENUFILESAVE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnSave);
    Connect(ID_MENUFILESAVEAS,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnSaveAs);
    Connect(ID_MENUFILECLOSE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnCloseCurrentTab);
    Connect(ID_MENUFILEQUIT,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnQuit);
    Connect(ID_MENUEDITUNDO,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnUndo);
    Connect(ID_MENUEDITREDO,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnRedo);
    Connect(ID_MENUEDITCUT,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnCut);
    Connect(ID_MENUEDITCOPY,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnCopy);
    Connect(ID_MENUEDITPASTE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnPaste);
    Connect(ID_MENUEDITSEARCH,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnToolSearch);
    Connect(ID_MENUEDITREPLACE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnToolReplace);
    Connect(ID_MENUVIEWFILE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnShowFile);
    Connect(ID_MENUVIEWEDIT,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnShowEdit);
    Connect(ID_MENUVIEWWRITE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnShowSend);
    Connect(ID_MENUVIEWSEARCH,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnShowSearch);
    Connect(ID_MENUWRITEWRITE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnWriteToSelection);
    Connect(ID_MENUWRITEAUTO,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnAutoWrite);
    Connect(ID_MENUHELPABOUT,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnAbout);
    Connect(ID_TABSAVE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnSave);
    Connect(ID_TABSAVEAS,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnSaveAs);
    Connect(ID_TABCLOSE,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnCloseCurrentTab);
    Connect(wxID_ANY,wxEVT_CLOSE_WINDOW,(wxObjectEventFunction)&LF2DataChangerFrame::OnClose);
    //*)

    AboutDlg = new AboutBox(NULL);
    #ifdef USE_WRITETOEXE
        WriteDlg = new WriteToDialog(NULL);
        TransDlg = new TransDialog(NULL);
    #endif

    Server = new DDEServer(this);

    #ifdef __WXMSW__
        Server->Create(_T("LF2DC"));
    #else
        Server->Create(wxString::Format(_T("/tmp/LF2DC%s.socket"),wxGetUserId().wx_str()));
    #endif

    Show();

    //newer versions of wxSmith screwed up the toolbars so they had captions, and were weird, this fixes that problem
    AuiManager->GetPane(_T("Notebook")).CaptionVisible(false);
    AuiManager->GetPane(_T("ToolbarFile")).CaptionVisible(false).Resizable(false);
    AuiManager->GetPane(_T("ToolbarEdit")).CaptionVisible(false).Resizable(false);
    AuiManager->GetPane(_T("ToolbarWrite")).CaptionVisible(false).Resizable(false);
    AuiManager->GetPane(_T("ToolbarSearch")).CaptionVisible(false).Resizable(false);

    SubMenus[ID_MENUFILETEMPLATE] = MenuFile->FindItem(ID_MENUFILETEMPLATE);
    SubMenus[ID_MENUFILERECENT] = MenuFile->FindItem(ID_MENUFILERECENT);
    SubMenus[ID_MENUWRITECHOOSE] = MenuWrite->FindItem(ID_MENUWRITECHOOSE);

    DragAcceptFiles(true);

    Connect(ID_AUITOOLBARFILENEW,wxEVT_COMMAND_AUITOOLBAR_TOOL_DROPDOWN,(wxObjectEventFunction)&LF2DataChangerFrame::OnPrepareNew);
    Connect(ID_AUITOOLBARFILEOPEN,wxEVT_COMMAND_AUITOOLBAR_TOOL_DROPDOWN,(wxObjectEventFunction)&LF2DataChangerFrame::OnPrepareOpen);
    Connect(ID_AUITOOLBARWRITEWRITE,wxEVT_COMMAND_AUITOOLBAR_TOOL_DROPDOWN,(wxObjectEventFunction)&LF2DataChangerFrame::OnPrepareWriteToExe);
    Connect(wxEVT_DROP_FILES,(wxObjectEventFunction)&LF2DataChangerFrame::OnDropFiles);
    Connect(wxEVT_MENU_OPEN,(wxObjectEventFunction)&LF2DataChangerFrame::OnMenuOpen);
    Connect(wxEVT_MENU_HIGHLIGHT,(wxObjectEventFunction)&LF2DataChangerFrame::OnMenuHighlight);

    #ifndef USE_WRITETOEXE
        MenuBar->Remove(3);
        MenuView->Remove(MenuViewWrite);
        AuiManager->GetPane(AuiToolBarWrite).Hide();
    #endif

    Searching = false;

    SetIcon(wxIcon(_T("aaaa")));

    {
        wxStandardPaths Paths;
        ExePath = Paths.GetExecutablePath();
    }

    ExePath.Replace(_T("\\"),_T("/"));

    ExePath = ExePath.substr(0,ExePath.rfind(_T("/"))+1);

    DontUpdateMenuFileRecent = true;

    LoadConfig();
    AuiManager->Update();

    //load files based on command line arguments
    CmdParser = LF2DataChangerApp::CmdParser;

    for(unsigned int i = 0;i<CmdParser->GetParamCount();++i){
        LoadFile(CmdParser->GetParam(i));
    }

    DontUpdateMenuFileRecent = false;

    UpdateMenuFileRecent();
}

LF2DataChangerFrame::~LF2DataChangerFrame(){
    //(*Destroy(LF2DataChangerFrame)
    //*)
}

void LF2DataChangerFrame::LoadConfig(){
    TiXmlDocument Doc;//the document used to read the configuration file

    wchar_t ConfigPath[MAX_PATH];
    wcscpy(ConfigPath,ExePath.wc_str());
    wcscat(ConfigPath,_T("config.cfg"));

    FILE *File = _wfopen(ConfigPath,_T("rb"));

    if(!File || !Doc.LoadFile(File)) return;//just in case we are unable to load the file (such as if it doesn't exist)

    fclose(File);

    TiXmlHandle Handle = &Doc;//create a handle, which makes handling the document far easier

    if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Client").ToElement()){//read data related to the client
        bool Maximized = GetXmlAttribute(Child,"Maximized","True") == "True";
        int Width; stringstream(GetXmlAttribute(Child,"Width","800")) >> Width;
        int Height; stringstream(GetXmlAttribute(Child,"Height","480")) >> Height;

        SetClientSize(Width,Height);
        Maximize(Maximized);
    }

    if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Toolbars").FirstChild("File").ToElement()){//read data related to AuiToolBarFile
        bool Visible = GetXmlAttribute(Child,"Visible","True") == "True";
        int Position; stringstream(GetXmlAttribute(Child,"Position","0")) >> Position;
        int Row; stringstream(GetXmlAttribute(Child,"Row","0")) >> Row;

        MenuViewFile->Check(Visible);

        AuiManager->GetPane(AuiToolBarFile).Show(Visible).Position(Position).Row(Row);
    }

    if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Toolbars").FirstChild("Edit").ToElement()){//read data related to AuiToolBarEdit
        bool Visible = GetXmlAttribute(Child,"Visible","True") == "True";
        int Position; stringstream(GetXmlAttribute(Child,"Position","0")) >> Position;
        int Row; stringstream(GetXmlAttribute(Child,"Row","0")) >> Row;

        MenuViewEdit->Check(Visible);

        AuiManager->GetPane(AuiToolBarEdit).Show(Visible).Position(Position).Row(Row);
    }

    #ifdef USE_WRITETOEXE
        if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Toolbars").FirstChild("Write").ToElement()){//read data related to AuiToolBarEdit
            bool Visible = GetXmlAttribute(Child,"Visible","True") == "True";
            int Position; stringstream(GetXmlAttribute(Child,"Position","0")) >> Position;
            int Row; stringstream(GetXmlAttribute(Child,"Row","0")) >> Row;

            if(GetXmlAttribute(Child,"Auto","False") == "True"){
                MenuWriteAuto->Check();

                AuiToolBarWrite->SetToolSticky(ID_AUITOOLBARWRITEAUTO,true);
            }

            MenuViewWrite->Check(Visible);

            AuiManager->GetPane(AuiToolBarWrite).Show(Visible).Position(Position).Row(Row);
        }
    #endif

    if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Toolbars").FirstChild("Search").ToElement()){//read data related to AuiToolBarSearch
        bool Visible = GetXmlAttribute(Child,"Visible","False") == "True";

        AuiManager->GetPane(AuiToolBarSearch).Show(Visible);

        if(Visible) MenuViewSearch->Check();
    }

    if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Dialogs").FirstChild("Search").ToElement()){//read data related to SearchDialog
        bool Visible = GetXmlAttribute(Child,"Visible","False") == "True";
        bool Docked = GetXmlAttribute(Child,"Docked","False") == "True";
        bool DockDirection = GetXmlAttribute(Child,"DockDirection","Left") == "Right";
        int FloatingWidth; stringstream(GetXmlAttribute(Child,"FloatingWidth","400")) >> FloatingWidth;
        int FloatingHeight; stringstream(GetXmlAttribute(Child,"FloatingHeight","300")) >> FloatingHeight;
        bool WholeWord = GetXmlAttribute(Child,"WholeWord","False") == "True";
        bool MatchCase = GetXmlAttribute(Child,"MatchCase","False") == "True";
        bool Direction = GetXmlAttribute(Child,"Direction","Down") == "Up";

        wxAuiPaneInfo &Pane = AuiManager->GetPane(SearchDialog);

        if(Visible) AuiManager->GetPane(AuiToolBarSearch).Hide();
        if(Docked) Pane.Dock();
        if(DockDirection) Pane.Right();
        Pane.Show(Visible).FloatingSize(wxSize(FloatingWidth,FloatingHeight));
        SearchDialogWholeWord->SetValue(WholeWord);
        SearchDialogMatchCase->SetValue(MatchCase);
        SearchDialogUp->SetValue(Direction);

        if(Visible) MenuViewSearch->Check();
    }

    if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Files").FirstChild("File").ToElement()){//read data related to files
        do {
            string Filename = GetXmlAttribute(Child,"Source","");
            if(Filename.empty()) continue;
            if(!LoadFile(wxString::FromUTF8(Filename.c_str(),Filename.length()),false,false)) continue;//in the event we are unable to load the file, we shouldn't do the loading

            #ifdef USE_WRITETOEXE
                int Id; stringstream(GetXmlAttribute(Child,"Id","0")) >> Id; CurrentPanel->Id = Id;
                int Type; stringstream(GetXmlAttribute(Child,"Type","0")) >> Type; CurrentPanel->Type = Type;
                unsigned int Addr; stringstream(GetXmlAttribute(Child,"Addr","0")) >> Addr; CurrentPanel->Addr = (char*)Addr;
            #endif
        }while((Child = Child->NextSiblingElement("File")));

        unsigned int Selection; stringstream(GetXmlAttribute(Handle.FirstChild("Config").FirstChild("Files").ToElement(),"Selection","-1")) >> Selection;

        if(Selection<AuiNotebook->GetPageCount()) AuiNotebook->SetSelection(Selection);
    }

    if(TiXmlElement *Child = Handle.FirstChild("Config").FirstChild("Files").FirstChild("Recent").FirstChild("File").ToElement()){//read data related to recent files
        do {
            string Filename = GetXmlAttribute(Child,"Source","");
            if(Filename.empty()) continue;
            UpdateMenuFileRecent(wxString::FromUTF8(Filename.c_str(),Filename.length()));
        }while((Child = Child->NextSiblingElement("File")));
    }
}

bool LF2DataChangerFrame::Destroy(){
    UpdateSearchBar();

    TiXmlDocument Doc;
    Doc.LinkEndChild(new TiXmlDeclaration("1.0","UTF-8",""));
    TiXmlElement *Config               = new TiXmlElement("Config"),
                 *ConfigClient         = new TiXmlElement("Client"),
                 *ConfigToolbars       = new TiXmlElement("Toolbars"),
                 *ConfigToolbarsFile   = new TiXmlElement("File"),
                 *ConfigToolbarsEdit   = new TiXmlElement("Edit"),
                 *ConfigToolbarsSearch = new TiXmlElement("Search"),
                 *ConfigDialogs        = new TiXmlElement("Dialogs"),
                 *ConfigDialogsSearch  = new TiXmlElement("Search"),
                 *ConfigFiles          = new TiXmlElement("Files"),
                 *ConfigFilesRecent    = new TiXmlElement("Recent");



    ConfigClient->SetAttribute("Maximized",IsMaximized()?"True":"False");

    Maximize(false);

    ConfigClient->SetAttribute("Width",GetClientSize().GetWidth());
    ConfigClient->SetAttribute("Height",GetClientSize().GetHeight());

    wxAuiPaneInfo *Pane = &(AuiManager->GetPane(AuiToolBarFile));

    ConfigToolbarsFile->SetAttribute("Visible",Pane->IsShown()?"True":"False");
    ConfigToolbarsFile->SetAttribute("Position",Pane->dock_pos);
    ConfigToolbarsFile->SetAttribute("Row",Pane->dock_row);

    Pane = &(AuiManager->GetPane(AuiToolBarEdit));

    ConfigToolbarsEdit->SetAttribute("Visible",Pane->IsShown()?"True":"False");
    ConfigToolbarsEdit->SetAttribute("Position",Pane->dock_pos);
    ConfigToolbarsEdit->SetAttribute("Row",Pane->dock_row);

    #ifdef USE_WRITETOEXE
        TiXmlElement *ConfigToolbarsWrite = new TiXmlElement("Write");

        Pane = &(AuiManager->GetPane(AuiToolBarWrite));

        ConfigToolbarsWrite->SetAttribute("Visible",Pane->IsShown()?"True":"False");
        ConfigToolbarsWrite->SetAttribute("Position",Pane->dock_pos);
        ConfigToolbarsWrite->SetAttribute("Row",Pane->dock_row);
        ConfigToolbarsWrite->SetAttribute("Auto",MenuWriteAuto->IsChecked()?"True":"False");
    #endif

    Pane = &(AuiManager->GetPane(AuiToolBarSearch));

    ConfigToolbarsSearch->SetAttribute("Visible",Pane->IsShown()?"True":"False");

    ConfigToolbars->LinkEndChild(ConfigToolbarsFile);
    ConfigToolbars->LinkEndChild(ConfigToolbarsEdit);
    #ifdef USE_WRITETOEXE
        ConfigToolbars->LinkEndChild(ConfigToolbarsWrite);
    #endif
    ConfigToolbars->LinkEndChild(ConfigToolbarsSearch);

    Pane = &(AuiManager->GetPane(SearchDialog));

    ConfigDialogsSearch->SetAttribute("Visible",Pane->IsShown()?"True":"False");
    ConfigDialogsSearch->SetAttribute("Docked",Pane->IsDocked()?"True":"False");
    ConfigDialogsSearch->SetAttribute("DockDirection",Pane->dock_direction == wxAUI_DOCK_LEFT?"Left":"Right");
    ConfigDialogsSearch->SetAttribute("FloatingWidth",Pane->floating_size.GetWidth());
    ConfigDialogsSearch->SetAttribute("FloatingHeight",Pane->floating_size.GetHeight());
    ConfigDialogsSearch->SetAttribute("WholeWord",SearchDialogWholeWord->IsChecked()?"True":"False");
    ConfigDialogsSearch->SetAttribute("MatchCase",SearchDialogMatchCase->IsChecked()?"True":"False");
    ConfigDialogsSearch->SetAttribute("Direction",SearchDialogUp->GetValue()?"Up":"Down");

    ConfigDialogs->LinkEndChild(ConfigDialogsSearch);

    for(unsigned int i = 0;i<AuiNotebook->GetPageCount();++i){
        EditorPanel *Panel = static_cast<EditorPanel*>(AuiNotebook->GetPage(i));

        if(Panel->Filename.find(_T("/")) >= Panel->Filename.length()) continue;

        TiXmlElement *Element = new TiXmlElement("File");

        Element->SetAttribute("Source",Panel->Filename.mb_str(wxConvUTF8));

        if(AuiNotebook->GetSelection() == (int)i) ConfigFiles->SetAttribute("Selection",i);

        #ifdef USE_WRITETOEXE
            if(CurrentPanel->Addr != (char*)0xfffffff){
                Element->SetAttribute("Id",CurrentPanel->Id);
                Element->SetAttribute("Type",CurrentPanel->Type);
                Element->SetAttribute("Addr",reinterpret_cast<int>(CurrentPanel->Addr));
            }
        #endif

        ConfigFiles->LinkEndChild(Element);
    }

    for(unsigned int i = 0;i<RecentFiles.size();++i){
        TiXmlElement *Element = new TiXmlElement("File");

        Element->SetAttribute("Source",RecentFiles.at(i).mb_str(wxConvUTF8));

        ConfigFilesRecent->LinkEndChild(Element);
    }

    ConfigFiles->LinkEndChild(ConfigFilesRecent);

    Config->LinkEndChild(ConfigClient);
    Config->LinkEndChild(ConfigToolbars);
    Config->LinkEndChild(ConfigDialogs);
    Config->LinkEndChild(ConfigFiles);

    Doc.LinkEndChild(Config);

    wchar_t ConfigPath[MAX_PATH];
    wcscpy(ConfigPath,ExePath.wc_str());
    wcscat(ConfigPath,_T("config.cfg"));

    FILE *File = _wfopen(ConfigPath,_T("wb"));

    if(File) Doc.SaveFile(File);

    fclose(File);

    delete Server;

    AboutDlg->Destroy();
    #ifdef USE_WRITETOEXE
        WriteDlg->Destroy();
        TransDlg->Destroy();
    #endif

    return wxFrame::Destroy();
}

void LF2DataChangerFrame::SetTabText(unsigned int Index,const wxString &Text){
    AuiNotebook->SetPageText(Index,Text);
}

void LF2DataChangerFrame::SetTabText(EditorPanel *Panel,const wxString &Text){
    SetTabText(AuiNotebook->GetPageIndex(Panel),Text);
}

void LF2DataChangerFrame::UpdateSearchBar(){
    if(!MenuViewSearch->IsChecked()){
        AuiManager->GetPane(AuiToolBarSearch).Hide();
        AuiManager->GetPane(SearchDialog).Hide();
    }else if(AuiManager->GetPane(SearchDialog).IsShown()){
        AuiManager->GetPane(AuiToolBarSearch).Hide();
    }
    AuiManager->Update();

    Searching = false;
}

void LF2DataChangerFrame::UpdateStatusBar(){
    if(!CurrentPanel){
        StatusBar->SetStatusText(_T(""),1);
        StatusBar->SetStatusText(_T(""),3);
        StatusBar->SetStatusText(_T(""),4);
        StatusBar->SetStatusText(_T(""),5);
        StatusBar->SetStatusText(_T(""),6);
        return;
    }

    switch(CurrentPanel->Editor->GetLexer()){
        case wxSTC_LEX_LF2AI:
            StatusBar->SetStatusText(_("AngelScript"),1);
        break;
        case wxSTC_LEX_LF2DC:
            StatusBar->SetStatusText(_("LF2 Data"),1);
        break;
    }

    wxString StatusText;
    StatusText.Printf(_("Ln: %d"),CurrentPanel->Editor->GetCurrentLine()+1);
    StatusBar->SetStatusText(StatusText,3);

    StatusText.Printf(_("Col: %d"),CurrentPanel->Editor->GetColumn(CurrentPanel->Editor->GetCurrentPos())+1);
    StatusBar->SetStatusText(StatusText,4);

    StatusText.Printf(_("Sel: %d"),CurrentPanel->Editor->GetSelectionEnd()-CurrentPanel->Editor->GetSelectionStart());
    StatusBar->SetStatusText(StatusText,5);

    StatusBar->SetStatusText(CurrentPanel->GetFilename(),6);
}

void LF2DataChangerFrame::UpdateTitle(){
    if(!CurrentPanel){
        SetTitle(_("LF2 Data Changer"));
        return;
    }

    wxString Title = AuiNotebook->GetPageText(AuiNotebook->GetSelection());

    if(Title.at(0) == '*') Title = Title.substr(1);

    Title.append(_(" - LF2 Data Changer"));

    SetTitle(Title);
}

void LF2DataChangerFrame::OnQuit(wxCommandEvent& event){
    Close();
}

void LF2DataChangerFrame::OnClose(wxCloseEvent& event){
    if(!event.CanVeto()){//is there even a reason to ask if changes should be saved
        Destroy();
        return;
    }

    for(unsigned int i = 0;i<AuiNotebook->GetPageCount();++i){
        EditorPanel *Panel = static_cast<EditorPanel*>(AuiNotebook->GetPage(i));

        if(Panel->Saved){
            continue;
        }
        wxMessageDialog* Dialog = new wxMessageDialog(this,wxString(_("You have unsaved changes in \""))+
                                                                    GetFilename(Panel)+
                                                                    _("\".\nDo you want to save them?")
                                                                    ,_("Save data"),wxYES_NO|wxCANCEL|wxICON_QUESTION);
        int Result = Dialog->ShowModal();
        Dialog->Destroy();

        switch(Result){
            case wxID_YES: {
                SaveFile(Panel);
                break;
            }
            case wxID_NO: {
                //don't do anything
                break;
            }
            default: {
                event.Veto();
                return;
            }
        }
    }

    Destroy();
}

void LF2DataChangerFrame::OnAbout(wxCommandEvent& event){
    AboutDlg->Show();
}

bool LF2DataChangerFrame::ShowHidePane(wxAuiPaneInfo &Pane){
    Pane.Show(!Pane.IsShown());
    AuiManager->Update();

    return Pane.IsShown();
}

void LF2DataChangerFrame::OnShowFile(wxCommandEvent& event){
    wxAuiPaneInfo &Pane = AuiManager->GetPane(AuiToolBarFile);
    MenuViewFile->Check(ShowHidePane(Pane));
}

void LF2DataChangerFrame::OnShowEdit(wxCommandEvent& event){
    wxAuiPaneInfo &Pane = AuiManager->GetPane(AuiToolBarEdit);
    MenuViewEdit->Check(ShowHidePane(Pane));
}

void LF2DataChangerFrame::OnShowSend(wxCommandEvent& event){
    #ifdef USE_WRITETOEXE
        wxAuiPaneInfo &Pane = AuiManager->GetPane(AuiToolBarWrite);
        MenuViewWrite->Check(ShowHidePane(Pane));
    #endif
}

void LF2DataChangerFrame::OnShowSearch(wxCommandEvent& event){
    wxAuiPaneInfo &Pane (AuiManager->GetPane(SearchDialog).IsShown()?AuiManager->GetPane(SearchDialog):AuiManager->GetPane(AuiToolBarSearch));
    MenuViewSearch->Check(ShowHidePane(Pane));
    Searching = false;
}

void LF2DataChangerFrame::OnRedo(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    wxStyledTextCtrl *Editor = CurrentPanel->Editor;
    if(Editor == NULL) return;

    Editor->Redo();
}

void LF2DataChangerFrame::OnUndo(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    wxStyledTextCtrl *Editor = CurrentPanel->Editor;
    if(Editor == NULL) return;

    Editor->Undo();
}

void LF2DataChangerFrame::OnCut(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    wxStyledTextCtrl *Editor = CurrentPanel->Editor;
    if(Editor == NULL) return;

    Editor->Cut();
}

void LF2DataChangerFrame::OnCopy(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    wxStyledTextCtrl *Editor = CurrentPanel->Editor;
    if(Editor == NULL) return;

    Editor->Copy();
}

void LF2DataChangerFrame::OnPaste(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    wxStyledTextCtrl *Editor = CurrentPanel->Editor;
    if(Editor == NULL) return;

    Editor->Paste();
}

void LF2DataChangerFrame::OnToolSearch(wxCommandEvent& event){
    if(Searching || AuiManager->GetPane(SearchDialog).IsShown()){
        AuiManager->GetPane(SearchDialog).Show();
        AuiManager->GetPane(AuiToolBarSearch).Hide();
        AuiManager->Update();

        SearchDialogSearchField->SetFocus();
    }else{
        Searching = true;

        AuiManager->GetPane(AuiToolBarSearch).Show();
        AuiManager->Update();

        AuiToolBarSearchField->SetFocus();
        AuiToolBarSearchField->SetSelection(0,AuiToolBarSearchField->GetLineLength(0));
    }
}

void LF2DataChangerFrame::OnToolReplace(wxCommandEvent& event){
    if(Searching || AuiManager->GetPane(SearchDialog).IsShown()){
        UpdateSearchBar();

        AuiManager->GetPane(SearchDialog).Show();
        AuiManager->GetPane(AuiToolBarSearch).Hide();
        AuiManager->Update();

        SearchDialogSearchReplace->SetFocus();
    }else{
        Searching = true;

        AuiManager->GetPane(AuiToolBarSearch).Show();
        AuiManager->Update();

        AuiToolBarSearchReplace->SetFocus();
        AuiToolBarSearchReplace->SetSelection(0,AuiToolBarSearchReplace->GetLineLength(0));
    }
}

void LF2DataChangerFrame::OnPageChanged(wxAuiNotebookEvent& event){
    CurrentPanel = static_cast<EditorPanel*>(AuiNotebook->GetPage(AuiNotebook->GetSelection()));

    UpdateStatusBar();
    UpdateTitle();

    if(CurrentPanel->Filename.find(_T("/")) >= CurrentPanel->Filename.length()){
        AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVE,true);
        MenuFileSave->Enable(true);
    }else{
        AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVE,!CurrentPanel->Saved);
        MenuFileSave->Enable(!CurrentPanel->Saved);
    }

    if(CurrentPanel->Editor->CanUndo()){
        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITUNDO,true);
        MenuEditUndo->Enable(true);
    }else{
        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITUNDO,false);
        MenuEditUndo->Enable(false);
    }
    if(CurrentPanel->Editor->CanRedo()){
        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITREDO,true);
        MenuEditRedo->Enable(true);
    }else{
        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITREDO,false);
        MenuEditRedo->Enable(false);
    }

    AuiToolBarWrite->EnableTool(ID_AUITOOLBARWRITEWRITE,CurrentPanel->Editor->GetLexer() == wxSTC_LEX_LF2DC);
    MenuWriteWrite->Enable(CurrentPanel->Editor->GetLexer() == wxSTC_LEX_LF2DC);

    AuiToolBarFile->Realize();
    AuiToolBarEdit->Realize();
    AuiToolBarWrite->Realize();
}

void LF2DataChangerFrame::OnPageClose(wxAuiNotebookEvent& event){
    EditorPanel *Panel = static_cast<EditorPanel*>(AuiNotebook->GetPage(event.GetSelection()));

    if(Panel->Saved){//is there even a reason to ask if changes should be saved
        return;
    }

    wxMessageDialog* Dialog;

    Dialog = new wxMessageDialog(this,wxString(_("You have unsaved changes in \""))+
                                               GetFilename(Panel)+
                                               _("\".\nDo you want to save them?")
                                               ,_("Save data?"),wxYES_NO|wxCANCEL|wxICON_QUESTION);

    int Result = Dialog->ShowModal();
    Dialog->Destroy();

    switch(Result){
        case wxID_YES: {
            SaveFile(Panel);
            break;
        }
        case wxID_NO: {
            //don't do anything
            break;
        }
        default:{
            event.Veto();
        }
    }
}

void LF2DataChangerFrame::OnPageClosed(wxAuiNotebookEvent& event){
    if(AuiNotebook->GetPageCount() == 0){
        CurrentPanel = NULL;

        UpdateStatusBar();
        UpdateTitle();

        AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVE,false);
        MenuFileSave->Enable(false);

        AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVEAS,false);
        MenuFileSaveAs->Enable(false);

        AuiToolBarFile->EnableTool(ID_AUITOOLBARFILECLOSE,false);
        MenuFileClose->Enable(false);

        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITUNDO,false);
        MenuEditUndo->Enable(false);

        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITREDO,false);
        MenuEditRedo->Enable(false);

        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITCUT,false);
        MenuEditCut->Enable(false);

        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITCOPY,false);
        MenuEditCopy->Enable(false);

        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITPASTE,false);
        MenuEditPaste->Enable(false);

        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITSEARCH,false);
        MenuEditSearch->Enable(false);

        AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITREPLACE,false);
        MenuEditReplace->Enable(false);

        AuiToolBarWrite->EnableTool(ID_AUITOOLBARWRITEWRITE,false);
        MenuWriteWrite->Enable(false);

        AuiToolBarFile->Realize();
        AuiToolBarEdit->Realize();
        AuiToolBarWrite->Realize();
    }
}

void LF2DataChangerFrame::OnBgDClick(wxAuiNotebookEvent& event){
    OnNewFile(event);
}

void LF2DataChangerFrame::OnTabMiddleUp(wxAuiNotebookEvent& event){
    OnPageClose(event);

    if(event.IsAllowed()){
        AuiNotebook->DeletePage(event.GetSelection());
        OnPageClosed(event);
    }
}

void LF2DataChangerFrame::CreateFile(wxString Text,wxString Filename){
    EditorPanel *Panel = new EditorPanel(AuiNotebook);

    Panel->Editor->SetFocus();
    Panel->Editor->SetText(Text);
	Panel->Editor->ConvertEOLs(wxSTC_EOL_LF);
    Panel->Editor->SetSavePoint();
    Panel->Editor->EmptyUndoBuffer();
    Panel->Filename = Filename;
    Panel->Saved = true;

    if(Filename.substr(Filename.find(_T("."))) == _T(".as")){
        Panel->UpdateLexer(wxSTC_LEX_LF2AI);
    }else{
        Panel->UpdateLexer(wxSTC_LEX_LF2DC);
    }

    wxString Name = _("Untitled");

    if(Filename.find(_T("/")) >= Filename.length()){
        Name.append(Filename);
    }else{
        Name = Filename.substr(Filename.rfind(_T("/"))+1);
    }

    if(!AuiNotebook->AddPage(Panel,Name)){
        Panel->Destroy();

        //output error
        return;
    }

    AuiNotebook->SetSelection(AuiNotebook->GetPageCount()-1);

    AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVEAS,true);
    MenuFileSaveAs->Enable(true);

    AuiToolBarFile->EnableTool(ID_AUITOOLBARFILECLOSE,true);
    MenuFileClose->Enable(true);

    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITCUT,true);
    MenuEditCut->Enable(true);

    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITCOPY,true);
    MenuEditCopy->Enable(true);

    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITPASTE,true);
    MenuEditPaste->Enable(true);

    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITSEARCH,true);
    MenuEditSearch->Enable(true);

    AuiToolBarEdit->EnableTool(ID_AUITOOLBAREDITREPLACE,true);
    MenuEditReplace->Enable(true);

    AuiToolBarFile->Realize();
    AuiToolBarEdit->Realize();
}

bool LF2DataChangerFrame::LoadFile(wxString Filename,bool Copy,bool Alert){
    Filename.Replace(_T("\\"),_T("/"));

    if(!Copy){
        for(unsigned int i = 0;i<AuiNotebook->GetPageCount();++i){//check if file is already opened
            EditorPanel *Panel = static_cast<EditorPanel*>(AuiNotebook->GetPage(i));
            if(Filename == Panel->Filename){
                AuiNotebook->SetSelection(i);

                UpdateMenuFileRecent(Filename);
                return true;
            }
        }
    }

    long long Length;
    char *Buffer;

    FILE *File = _wfopen(Filename.wc_str(),_T("rb"));//we are using C code because C++ doesn't fully support unicode file names

    if(!File){
        if(Alert){
            wxMessageDialog* Dialog = new wxMessageDialog(this,wxString(_("Unable to load \""))+
                                                                        Filename.substr(Filename.rfind(_T("/"))+1)+
                                                                        _T("\".")
                                                                        ,_("Error"),wxOK|wxICON_ERROR);
            Dialog->ShowModal();
            Dialog->Destroy();
        }

        return false;
    }

    fseeko64(File,0,SEEK_END);
    Length = ftello64(File);
    fseeko64(File,0,SEEK_SET);

    if(Length>0xffffffff){
        if(Alert){
            wxMessageDialog* Dialog = new wxMessageDialog(this,wxString(_("The file \""))+
                                                                        Filename.substr(Filename.rfind(_T("/"))+1)+
                                                                        _T("\" is too big to be opened.")
                                                                        ,_("Error"),wxOK|wxICON_ERROR);
            Dialog->ShowModal();
            Dialog->Destroy();
        }

        return false;
    }

    Buffer = new char[Length];

    fread(Buffer,1,Length,File);
    fclose(File);//the data is now stored in Buffer, so we don't need the file any longer

    //read the string that was retrieved from the file
    stringstream Stream;
    Stream.write(Buffer,Length);
    string Content = Stream.str();

    delete[] Buffer;//the buffer is no longer needed, as the data is stored in Content

    if(Length>123 && Filename.substr(Filename.rfind(_T("."))) == _T(".dat")){//is it a datafile?
        DecryptString(Content,Length);//if it is, then decrypt it
    }

    CreateFile(wxString::From8BitData(Content.c_str(),Content.length()),Copy?Filename.substr(Filename.rfind(_T("."))):Filename);

    UpdateMenuFileRecent(Filename);
    return true;
}

void LF2DataChangerFrame::SaveFile(EditorPanel *Panel){
    if(Panel->Filename.find(_T("/")) >= Panel->Filename.length()){
        SaveFileAs(Panel);
        return;
    }

    wxString Text = Panel->Editor->GetText();

    string Content = (const char*)Text.mb_str();

    if(Panel->Filename.substr(Panel->Filename.rfind(_T("."))) == _T(".dat")){//is it a datafile?
        EncryptString(Content,Content.length());//if it is, then encrypt it
    }

    FILE *File = _wfopen(Panel->Filename.wc_str(),_T("wb"));//we are using C code because C++ doesn't fully support unicode file names
    if(!File){
        wxMessageDialog* Dialog = new wxMessageDialog(this,wxString(_("Unable to save \""))+
                                                                    GetFilename(Panel)+
                                                                    _T("\".")
                                                                    ,_("Error"),wxOK|wxICON_ERROR);
        Dialog->ShowModal();
        Dialog->Destroy();

        return;
    }

    fwrite(Content.data(),1,Content.length(),File);//write data to the file

    fclose(File);

    //reflect the changes so the user knows his file was saved
    Panel->Editor->SetSavePoint();
    Panel->Saved = true;

    if(Panel->Filename.substr(Panel->Filename.find(_T("."))) == _T(".as")){
        Panel->UpdateLexer(wxSTC_LEX_LF2AI);
    }else{
        Panel->UpdateLexer(wxSTC_LEX_LF2DC);
    }

    SetTabText(Panel,Panel->Filename.substr(Panel->Filename.rfind(_T("/"))+1));
    UpdateTitle();

    AuiToolBarFile->EnableTool(ID_AUITOOLBARFILESAVE,false);
    MenuFileSave->Enable(false);
    AuiToolBarFile->Realize();

    #ifdef USE_WRITETOEXE
        if(MenuWriteAuto->IsChecked()){
            WriteDropdownClicked = false;
            wxCommandEvent event;
            OnWriteToExe(event);
        }
    #endif
}

void LF2DataChangerFrame::SaveFileAs(EditorPanel *Panel){
    if(SaveFileDlg->ShowModal() == wxID_CANCEL) return;

    Panel->Filename = SaveFileDlg->GetDirectory()+_T("/")+SaveFileDlg->GetFilename();
    Panel->Filename.Replace(_T("\\"),_T("/"));

    UpdateMenuFileRecent(Panel->Filename);

    SaveFile(Panel);
}

wxString LF2DataChangerFrame::GetFilename(EditorPanel *Panel){
    for(unsigned int i = 0;i<AuiNotebook->GetPageCount();++i){
        if(Panel != AuiNotebook->GetPage(i)) continue;

        if(AuiNotebook->GetPageText(i).at(0) == '*'){
            return AuiNotebook->GetPageText(i).substr(1);
        }
        return AuiNotebook->GetPageText(i).substr(1);
    }

    return _T("");
}

void LF2DataChangerFrame::DecryptString(string &String,unsigned int Length,wxString Key){
    for(unsigned int i = 0;i<Length;++i){
        String[i] -= Key.at(i%Key.length());
    }
    String = String.substr(123);
}

void LF2DataChangerFrame::EncryptString(string &String,unsigned int Length,wxString Key,wxString Notice){
    for(unsigned int i = 0;i<Length;++i){
        String[i] += Key.at((i+123)%Key.length());
    }

    while(Notice.Length()<123){
        Notice.append(_T(" "));
    }
    if(Notice.Length()>123){
        Notice = Notice.substr(0,123);
    }

    String.insert(0,Notice.mb_str());
}

void LF2DataChangerFrame::OnDropFiles(wxDropFilesEvent& event){
    for(int i = 0;i<event.GetNumberOfFiles();++i){
        wxString Filename = event.GetFiles()[i];
        LoadFile(Filename);
    }
}

void LF2DataChangerFrame::OnPrepareNew(wxAuiToolBarEvent& event){
    if(event.IsDropDownClicked()){
        NewDropdownClicked = true;
    }else{
        NewDropdownClicked = false;
    }
}

void LF2DataChangerFrame::OnNew(wxCommandEvent& event){
    if(NewDropdownClicked){
        AuiToolBarFile->SetToolSticky(ID_AUITOOLBARFILENEW,true);

        UpdateMenuFileTemplate();
        PopupMenu(MenuFileTemplate,ScreenToClient(AuiToolBarFile->ClientToScreen(AuiToolBarFile->GetToolRect(ID_AUITOOLBARFILENEW).GetBottomLeft())));

        AuiToolBarFile->SetToolSticky(ID_AUITOOLBARFILENEW,false);
    }else{
        OnNewFile(event);
    }
}

void LF2DataChangerFrame::OnNewFile(wxCommandEvent& event){
    CreateFile(_T(""),_T(".dat"));
}

void LF2DataChangerFrame::OnNewTemplate(wxCommandEvent& event){
    wxString Path = ExePath+_T("templates/");

    if(TemplateFiles.count(event.GetId()) == 0) return;

    Path.append(TemplateFiles.at(event.GetId()));

    LoadFile(Path,true);
}

void LF2DataChangerFrame::OnPrepareOpen(wxAuiToolBarEvent& event){
    if(event.IsDropDownClicked()){
        OpenDropdownClicked = true;
    }else{
        OpenDropdownClicked = false;
    }
}

void LF2DataChangerFrame::OnOpen(wxCommandEvent& event){
    if(OpenDropdownClicked){
        AuiToolBarFile->SetToolSticky(ID_AUITOOLBARFILEOPEN,true);

        PopupMenu(MenuFileRecent,ScreenToClient(AuiToolBarFile->ClientToScreen(AuiToolBarFile->GetToolRect(ID_AUITOOLBARFILEOPEN).GetBottomLeft())));

        AuiToolBarFile->SetToolSticky(ID_AUITOOLBARFILEOPEN,false);
    }else{
        OnOpenFile(event);
    }
}

void LF2DataChangerFrame::OnOpenFile(wxCommandEvent& event){
    if(OpenFileDlg->ShowModal() == wxID_CANCEL) return;

    wxArrayString Files;
    OpenFileDlg->GetFilenames(Files);
    wxString Dir = OpenFileDlg->GetDirectory();
    if(Files.IsEmpty()) return;

    for(unsigned int i = 0;i<Files.Count();++i){
        wxString Filename = Dir+_T("/")+Files.Item(i);
        LoadFile(Filename);//load the file
    }
}

void LF2DataChangerFrame::OnOpenRecent(wxCommandEvent& event){
    std::map<long,unsigned int>::iterator it = RecentFilesMap.find(event.GetId());

    if(it == RecentFilesMap.end()) return;

    if(!LoadFile(RecentFiles.at(it->second))){
        RecentFiles.erase(RecentFiles.begin()+it->second);
        UpdateMenuFileRecent();
    }
}

void LF2DataChangerFrame::OnSave(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    SaveFile(CurrentPanel);
}

void LF2DataChangerFrame::OnSaveAs(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    SaveFileAs(CurrentPanel);
}

void LF2DataChangerFrame::OnCloseCurrentTab(wxCommandEvent& event){
    if(AuiNotebook->GetPageCount() == 0) return;

    wxAuiNotebookEvent event2;
    event2.SetClientData(event.GetClientData());
    event2.SetClientObject(event.GetClientObject());
    event2.SetEventObject(event.GetEventObject());
    event2.SetEventType(event.GetEventType());
    event2.SetExtraLong(event.GetExtraLong());
    event2.SetId(event.GetId());
    event2.SetInt(event.GetInt());
    event2.SetRefData(event.GetRefData());
    event2.SetSelection(AuiNotebook->GetSelection());
    event2.SetString(event.GetString());
    event2.SetTimestamp(event.GetTimestamp());

    OnPageClose(event2);

    if(event2.IsAllowed()){
        AuiNotebook->DeletePage(AuiNotebook->GetSelection());
        OnPageClosed(event2);
    }
}

void LF2DataChangerFrame::OnSearch(wxCommandEvent& event){
    if(CurrentPanel == NULL) return;

    wxStyledTextCtrl *Editor = CurrentPanel->Editor;

    int Pos1,Pos2;
    Editor->GetSelection(&Pos1,&Pos2);

    wxString Text;

    if(AuiManager->GetPane(SearchDialog).IsShown()){
        Text = SearchDialogSearchField->GetLineText(0);
    }else{
        Text = AuiToolBarSearchField->GetLineText(0);
    }

    if(Text.IsEmpty()) return;

    int Flags = 0;
    if(SearchDialogWholeWord->IsChecked()) Flags |= wxSTC_FIND_WHOLEWORD;
    if(SearchDialogMatchCase->IsChecked()) Flags |= wxSTC_FIND_MATCHCASE;

    int SearchStart,SearchEnd;

    if(SearchDialogUp->GetValue()){
        SearchStart = Editor->GetText().length();
        SearchEnd   = (Pos1 == Pos2?Pos1:Pos1+1);
    }else{
        SearchStart = (Pos1 == Pos2?Pos2:Pos2-1);
        SearchEnd   = Editor->GetText().length();
    }

    int Pos = Editor->FindText(SearchStart,SearchEnd,Text,Flags);

    if(Pos == -1){
    if(SearchDialogUp->GetValue()){
        SearchStart = Editor->GetText().length();
        SearchEnd   = 0;
    }else{
        SearchStart = 0;
        SearchEnd   = Editor->GetText().length();
    }

        Pos = Editor->FindText(SearchStart,SearchEnd,Text,Flags);
    }

    if(Pos != -1) Editor->SetSelection(Pos,Pos+Text.length());

    if(event.GetEventObject() != SearchDialogReplaceAllButton){
        UpdateSearchBar();
        if(Pos != -1) Editor->SetFocus();
    }
}

void LF2DataChangerFrame::OnReplace(wxCommandEvent& event){
    wxStyledTextCtrl *Editor = CurrentPanel->Editor;

    wxString Find,Text,SelText;

    if(AuiManager->GetPane(SearchDialog).IsShown()){
        Find = SearchDialogSearchField->GetLineText(0);
        Text = SearchDialogSearchReplace->GetLineText(0);
    }else{
        Find = AuiToolBarSearchField->GetLineText(0);
        Text = AuiToolBarSearchReplace->GetLineText(0);
    }

    SelText = Editor->GetSelectedText();

    if(!SearchDialogMatchCase->IsChecked()){
        SelText.LowerCase();
    }

    if(Find.IsEmpty()) return;

    if(Find == SelText){
        Editor->ReplaceSelection(Text);
    }

    OnSearch(event);
}

void LF2DataChangerFrame::OnReplaceAll(wxCommandEvent& event){
    wxStyledTextCtrl *Editor = CurrentPanel->Editor;
    wxString Find,Text;

    Editor->SetSelection(0,0);

    if(AuiManager->GetPane(SearchDialog).IsShown()){
        Find = SearchDialogSearchField->GetLineText(0);
        Text = SearchDialogSearchReplace->GetLineText(0);
    }else{
        Find = AuiToolBarSearchField->GetLineText(0);
        Text = AuiToolBarSearchReplace->GetLineText(0);
    }

    if(Find.IsEmpty()) return;

    int Pos = 0;

    do {
        OnReplace(event);

        if(Pos>Editor->GetSelectionEnd()) break;
        Pos = Editor->GetSelectionEnd();
    }while(!Editor->GetSelectedText().IsEmpty());

    UpdateSearchBar();
    Editor->SetFocus();
}

void LF2DataChangerFrame::OnPaneClose(wxAuiManagerEvent& event){
    if(event.GetPane() == &(AuiManager->GetPane(SearchDialog))){
        MenuViewSearch->Check(false);
        Searching = false;
    }
}

string LF2DataChangerFrame::GetXmlAttribute(TiXmlElement* Element,const string &Attribute,const string &Default){
    if(!Element->Attribute(Attribute)) return Default;
    return *Element->Attribute(Attribute);
}

void LF2DataChangerFrame::OnPrepareWriteToExe(wxAuiToolBarEvent& event){
    #ifdef USE_WRITETOEXE
        if(event.IsDropDownClicked()){
            WriteDropdownClicked = true;
        }else{
            WriteDropdownClicked = false;
        }
    #endif
}

#ifdef USE_WRITETOEXE
    struct DFStruct {
        HWND Window;
        int Pid;
        int Id;
        int Type;
        char *Addr;
    };
#endif

void LF2DataChangerFrame::OnWriteToExe(wxCommandEvent& event){
    #ifdef USE_WRITETOEXE
        if(WriteDropdownClicked){
            AuiToolBarWrite->SetToolSticky(ID_AUITOOLBARWRITEWRITE,true);

            UpdateMenuWriteChoose();
            PopupMenu(MenuWriteChoose,ScreenToClient(AuiToolBarWrite->ClientToScreen(AuiToolBarWrite->GetToolRect(ID_AUITOOLBARWRITEWRITE).GetBottomLeft())));

            AuiToolBarWrite->SetToolSticky(ID_AUITOOLBARWRITEWRITE,false);
        }else{
            if(!CurrentPanel) return;

            if(wxGetKeyState(WXK_CONTROL)){
                CurrentPanel->Pid = -1;
                CurrentPanel->Id = 0;
                CurrentPanel->Type = 0;
                CurrentPanel->Addr = (char*)0xffffffff;
            }

            if(CurrentPanel->Addr != (char*)0xffffffff && CurrentPanel->Pid != -1){
                PauseResumeThreadList(CurrentPanel->Pid,false);
                WriteToExe(CurrentPanel->Pid,CurrentPanel->Id,CurrentPanel->Type,CurrentPanel->Addr);
                PauseResumeThreadList(CurrentPanel->Pid,true);
                return;
            }

            DFStruct Window;
            Window.Pid = -1;

            wxString Str = CurrentPanel->Filename;
            Str.Replace(_T("/"),_T("\\"));
            wcscpy(CurrentFilename,Str.wc_str());
            if(EnumWindows(EnumWindowsProcAdv,(LPARAM)&Window) == 0) return;

            if(Window.Pid == -1) return;

            PauseResumeThreadList(Window.Pid,false);
            WriteToExe(Window.Pid,Window.Id,Window.Type,Window.Addr);
            PauseResumeThreadList(Window.Pid,true);
        }
    #endif
}

void LF2DataChangerFrame::UpdateMenuFileTemplate(){
    //clear the current menu
    if(MenuFileTemplate->FindItem(ID_MENUFILETEMPLATEEMPTY)){
        MenuFileTemplate->Remove(MenuFileTemplateEmpty);
    }else{
        while(MenuFileTemplate->GetMenuItemCount()>0){
            MenuFileTemplate->Destroy(MenuFileTemplate->FindItemByPosition(0));
        }
    }

    if(wxDirExists(ExePath+_T("templates"))){
        wxDir Templates(ExePath+_T("templates"));

        if(Templates.IsOpened()){
            wxString Filename;

            TemplateFiles.clear();

            if(Templates.GetFirst(&Filename,_T("*.*"),wxDIR_FILES)){
                do {
                    int ID = wxNewId();

                    MenuFileTemplate->Append(new wxMenuItem(MenuFileTemplate,ID,Filename.substr(0,Filename.find(_T("."))),_("Create a new file, based on \"")+Filename+_T("\""),wxITEM_NORMAL));

                    TemplateFiles[ID] = Filename;

                    Connect(ID,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnNewTemplate);
                }while(Templates.GetNext(&Filename));
            }
        }
    }

    if(MenuFileTemplate->GetMenuItemCount()>0){
        if(!MenuFile->FindItem(ID_MENUFILETEMPLATE)) MenuFile->Insert(1,SubMenus.at(ID_MENUFILETEMPLATE));
    }else{
        if(!MenuFileTemplate->FindItem(ID_MENUFILETEMPLATEEMPTY)) MenuFileTemplate->Append(MenuFileTemplateEmpty);
        if(MenuFile->FindItem(ID_MENUFILETEMPLATE)) MenuFile->Remove(ID_MENUFILETEMPLATE);
    }
}

void LF2DataChangerFrame::UpdateMenuFileRecent(){
    //clear the current menu
    if(MenuFileRecent->FindItem(ID_MENUFILERECENTEMPTY)){
        MenuFileRecent->Remove(ID_MENUFILERECENTEMPTY);
    }else{
        while(MenuFileRecent->GetMenuItemCount()>0){
            MenuFileRecent->Destroy(MenuFileRecent->FindItemByPosition(0));
        }
    }

    RecentFilesMap.clear();

    for(unsigned int i = RecentFiles.size();i>0;i--){
        int ID = wxNewId();

        wxString Filename = RecentFiles.at(i-1);

        MenuFileRecent->Append(new wxMenuItem(MenuFileRecent,ID,Filename.substr(Filename.rfind(_T("/"))+1),_("Open \"")+Filename+_T("\""),wxITEM_NORMAL));

        RecentFilesMap[ID] = i-1;

        Connect(ID,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnOpenRecent);
    }

    if(MenuFileRecent->GetMenuItemCount()>0){
        if(!MenuFile->FindItem(ID_MENUFILERECENT)) MenuFile->Insert(1,SubMenus.at(ID_MENUFILERECENT));
    }else{
        if(!MenuFileRecent->FindItem(ID_MENUFILERECENTEMPTY)) MenuFileRecent->Append(MenuFileRecentEmpty);
        if(MenuFile->FindItem(ID_MENUFILERECENT)) MenuFile->Remove(ID_MENUFILERECENT);
    }
}

void LF2DataChangerFrame::UpdateMenuFileRecent(const wxString &Filename){
    for(unsigned int i = 0;i<RecentFiles.size();++i){
        if(RecentFiles.at(i) == Filename){
            RecentFiles.erase(RecentFiles.begin()+i);
            break;
        }
    }

    RecentFiles.push_back(Filename);

    if(RecentFiles.size()>20){
        RecentFiles.erase(RecentFiles.end());
    }

    if(!DontUpdateMenuFileRecent){
        UpdateMenuFileRecent();
    }
}

#ifdef USE_WRITETOEXE
    void LF2DataChangerFrame::UpdateMenuWriteChoose(){
        //clear the current menu
        if(MenuWriteChoose->FindItem(ID_MENUWRITECHOOSEEMPTY)){
            MenuWriteChoose->Remove(MenuWriteChooseEmpty);
        }else{
            while(MenuWriteChoose->GetMenuItemCount()>0){
                MenuWriteChoose->Destroy(MenuWriteChoose->FindItemByPosition(0));
            }
        }

        if(CurrentPanel && CurrentPanel->Editor->GetLexer() == wxSTC_LEX_LF2DC){
            vector<HWND> Windows;
            if(EnumWindows(EnumWindowsProcAll,(LPARAM)&Windows) != 0){
                MatchingProcs.clear();

                for(vector<HWND>::iterator it = Windows.begin();it != Windows.end();++it){
                    int ID = wxNewId();

                    unsigned long Pid;

                    GetWindowThreadProcessId(*it,&Pid);

                    wchar_t Title[80];
                    GetWindowText(*it,Title,sizeof(Title));

                    wxString FinalTitle;

                    if(Pid<10){
                        FinalTitle << _T("000");
                    }else if(Pid<100){
                        FinalTitle << _T("00");
                    }else if(Pid<1000){
                        FinalTitle << _T("0");
                    }

                    FinalTitle << Pid << _T("-") << Title;

                    MenuWriteChoose->Append(new wxMenuItem(MenuWriteChoose,ID,FinalTitle,_("Write to \"")+FinalTitle+_T("\""),wxITEM_NORMAL));

                    ProcStruct Struct = {*it,(int)Pid};

                    MatchingProcs[ID] = Struct;

                    Connect(ID,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&LF2DataChangerFrame::OnWriteToSelection);
                }
            }
        }

        if(MenuWriteChoose->GetMenuItemCount()>0){
            if(!MenuWrite->FindItem(ID_MENUWRITECHOOSE)) MenuWrite->Insert(1,SubMenus.at(ID_MENUWRITECHOOSE));
        }else{
            if(!MenuWriteChoose->FindItem(ID_MENUWRITECHOOSEEMPTY)) MenuWriteChoose->Append(MenuWriteChooseEmpty);
            if(MenuWrite->FindItem(ID_MENUWRITECHOOSE)) MenuWrite->Remove(ID_MENUWRITECHOOSE);
        }
    }
#endif

void LF2DataChangerFrame::OnMenuOpen(wxMenuEvent& event){
    if(event.GetMenu() == MenuFile){//update MenuFileTemplate to update the templates, in case new ones were added
        UpdateMenuFileTemplate();
    }

    #ifdef USE_WRITETOEXE
        if(event.GetMenu() == MenuWrite){//update MenuWriteChoose to reflect LF2 processes currently running
            UpdateMenuWriteChoose();
        }
    #endif
}

void LF2DataChangerFrame::OnMenuHighlight(wxMenuEvent& event){
    wxFrame::OnMenuHighlight(event);
    if(TabMenu.FindItem(event.GetId())) SetStatusText(TabMenu.GetHelpString(event.GetId()),0);

    #ifdef USE_WRITETOEXE
        std::map<long,ProcStruct>::iterator it = MatchingProcs.find(event.GetMenuId());
        if(it == MatchingProcs.end()){
            TransDlg->Hide();
            return;
        }

        HWND Window = it->second.Window;

        RECT Rect;
        GetWindowRect(Window,&Rect);

        TransDlg->Show(Rect.left,Rect.top,Rect.right,Rect.bottom);
    #endif
}

void LF2DataChangerFrame::OnWriteToSelection(wxCommandEvent& event){
    #ifdef USE_WRITETOEXE
        if(!CurrentPanel) return;

        bool UpdateAddr = false;

        if(event.GetId() == ID_MENUWRITEWRITE){
            WriteDropdownClicked = false;
            OnWriteToExe(event);
            return;
        }else{
            std::map<long,ProcStruct>::iterator it = MatchingProcs.find(event.GetId());
            if(it == MatchingProcs.end()) return;

            if(CurrentPanel->Pid != -1 && CurrentPanel->Pid != it->second.Pid && CurrentPanel->Addr != (char*)offsetof(sFileManager,stages)) UpdateAddr = true;

            CurrentPanel->Pid = it->second.Pid;
        }

        if(wxGetKeyState(WXK_CONTROL) || CurrentPanel->Addr == (char*)0xffffffff){
            UpdateAddr = false;
            if(!WriteDlg->Prepare(CurrentPanel)) return;

            int Res = WriteDlg->ShowModal();
            if(Res == wxID_OK){
                CurrentPanel->Id = WriteDlg->Id;
                CurrentPanel->Type = WriteDlg->Type;
                CurrentPanel->Addr = WriteDlg->Addr;
            }else{
                CurrentPanel->Pid = -1;
                CurrentPanel->Id = 0;
                CurrentPanel->Type = 0;
                CurrentPanel->Addr = (char*)0xffffffff;

                return;
            }
        }

        if(UpdateAddr){
            HANDLE Proc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,CurrentPanel->Pid);

            if(Proc == INVALID_HANDLE_VALUE) return;

            char DataPath[0x10];//0x10 is the maximal length of the path to data.txt
            wchar_t DataPathW[sizeof(DataPath)];
            wchar_t Filename[MAX_PATH];

            if(GetModuleFileNameEx(Proc,NULL,Filename,MAX_PATH) == 0){
                CloseHandle(Proc);
                return;
            }

            if(ReadProcessMemory(Proc,(void*)0x448980,DataPath,sizeof(DataPath)-1,NULL) == 0){
                CloseHandle(Proc);
                return;
            }

            CloseHandle(Proc);

            DataPath[sizeof(DataPath)-1] = '\0';//add a null terminator at the end
            mbstowcs(DataPathW,DataPath,sizeof(DataPath));

            wcscpy(wcsrchr(Filename,'\\')+1,DataPathW);//make Filename the full path to data.txt

            FILE *File = _wfopen(Filename,_T("r"));//open data.txt

            if(!File) return;

            int Id = 0;
            char Buffer[MAX_PATH];
            char *Addr = offsetof(sFileManager,datas);
            char *BgrOffset = (char*)offsetof(sFileManager,backgrounds);
            bool WaitingForId = true;
            bool IsBackground = CurrentPanel->Addr >= (char*)offsetof(sFileManager,backgrounds);//check if we are working with a background
            bool Succeeded = false;

            while(!feof(File)){
                fgetword(Buffer,sizeof(Buffer),File);
                if(strcmp(Buffer,"id:") == 0){
                    fgetword(Buffer,sizeof(Buffer),File);
                    Id = atoi(Buffer);

                    WaitingForId = false;
                }else if(strcmp(Buffer,"type:") == 0){
                    if(!IsBackground) fgetword(Buffer,sizeof(Buffer),File);
                }else if(strcmp(Buffer,"file:") == 0){
                    if(WaitingForId) continue;

                    if(Addr >= BgrOffset){
                        if(IsBackground && CurrentPanel->Id == Id){
                            CurrentPanel->Addr = Addr;
                            Succeeded = true;
                            break;
                        }

                        Addr += sizeof(sBackground);
                    }else{
                        if(!IsBackground && CurrentPanel->Id == Id){
                            CurrentPanel->Addr = Addr;
                            Succeeded = true;
                            break;
                        }

                        Addr += 4;
                    }

                    fgetword(Buffer,sizeof(Buffer),File);

                    WaitingForId = true;
                }else if(strcmp(Buffer,"<background>") == 0){
                    Addr = BgrOffset;
                }
            }

            fclose(File);//close data.txt

            if(!Succeeded){
                CurrentPanel->Pid = -1;
                CurrentPanel->Id = 0;
                CurrentPanel->Type = 0;
                CurrentPanel->Addr = (char*)0xffffffff;
                return;
            }
        }

        PauseResumeThreadList(CurrentPanel->Pid,false);
        WriteToExe(CurrentPanel->Pid,CurrentPanel->Id,CurrentPanel->Type,CurrentPanel->Addr);
        PauseResumeThreadList(CurrentPanel->Pid,true);
    #endif
}

enum LF2DataType {
    LF2DT_STAGE,
    LF2DT_OBJECT,
    LF2DT_BACKGROUND
};

#include <fstream>

#ifdef USE_WRITETOEXE
    void LF2DataChangerFrame::WriteToExe(int Pid,int Id,int Type,char *Addr){
        if(!CurrentPanel) return;

        HANDLE Proc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,Pid);
        if(Proc == INVALID_HANDLE_VALUE){
            CurrentPanel->Pid = -1;
            return;
        }

        LF2DataType DataType = Addr<(char*)offsetof(sFileManager,backgrounds)?(Addr<(char*)offsetof(sFileManager,stages)?LF2DT_OBJECT:LF2DT_STAGE):LF2DT_OBJECT;//what data type are we working with

        {//TempAddr should be temporary, so we put it in another scope
            unsigned int TempAddr;

            if(ReadProcessMemory(Proc,(void*)0x4592d4,&TempAddr,4,NULL) == 0){
                CloseHandle(Proc);
                return;
            }

            Addr += TempAddr;
        }

        if(DataType == LF2DT_BACKGROUND){
            //backgrounds are not supported yet
        }else if(DataType == LF2DT_STAGE){
            sStage (&RStage)[60] = *(sStage (*)[60])malloc(sizeof(sStage)*60);//we have to allocate this otherwise it gives us a segmentation fault

            if(!RStage){
                CloseHandle(Proc);
                return;
            }

            if(ReadProcessMemory(Proc,Addr,RStage,sizeof(sStage)*60,NULL) == 0){
                CloseHandle(Proc);
                return;
            }

            sStage (&Stage)[60] = *(sStage (*)[60])malloc(sizeof(sStage)*60);//we have to allocate this otherwise it gives us a segmentation fault
            if(!Stage){
                free(RStage);
                CloseHandle(Proc);
                return;
            }
            memset(Stage,0,sizeof(sStage)*60);

            for(unsigned int i = 0;i<60;++i){
                Stage[i].phase_count = -1;
                for(unsigned int j = 0;j<100;++j){
                    Stage[i].phases[j].when_clear_goto_phase = -1;
                    for(unsigned int k = 0;k<60;++k){
                        Stage[i].phases[j].spawns[k].id = -1;

                        memcpy(Stage[i].phases[j].spawns[k].unkwn1,RStage[i].phases[j].spawns[k].unkwn1,sizeof(sSpawn::unkwn1));
                        Stage[i].phases[j].spawns[k].unkwn2 = RStage[i].phases[j].spawns[k].unkwn2;
                        Stage[i].phases[j].spawns[k].unkwn3 = RStage[i].phases[j].spawns[k].unkwn3;
                    }
                }
            }

            stringstream File;
            File.str((const char*)CurrentPanel->Editor->GetText().mb_str());

            string Buffer;

            bool SkipReadBuffer = false;

            while(!File.eof()){
                if(SkipReadBuffer){
                    SkipReadBuffer = false;
                }else{
                    File >> Buffer;
                }

                if(Buffer == "<stage>"){
                    int Id = -1;


                    while(Buffer != "<stage_end>" && !File.eof()){
                        if(SkipReadBuffer){
                            SkipReadBuffer = false;
                        }else{
                            File >> Buffer;
                        }

                        errno = 0;
                        char *EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                        if(Buffer == "id:"){
                            if(Id >= 0 && Id<60) continue;
                            File >> Buffer;
                            Id = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "<phase>"){
                            if(Id<0){
                                free(Stage);
                                CloseHandle(Proc);
                                return;
                            }

                            if(Id >= 60 || Stage[Id].phase_count >= 99) continue;

                            ++Stage[Id].phase_count;

                            int CurrentSpawn = -1;

                            while(Buffer != "<phase_end>" && !File.eof()){
                                File >> Buffer;

                                errno = 0;
                                char *EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                                if(Buffer == "bound:"){
                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].bound = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "music:"){
                                    File >> Buffer;
                                    strcpy(Stage[Id].phases[Stage[Id].phase_count].music,Buffer.c_str());
                                }else if(Buffer == "when_clear_goto_phase:"){
                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].when_clear_goto_phase = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "id:"){
                                    if(CurrentSpawn >= 60 || ++CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].id = strtol(Buffer.c_str(),&EndPos,10);
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].x = Stage[Id].phases[Stage[Id].phase_count].bound+80;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].hp = 500;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].times = 1;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].act = 9;
                                }else if(Buffer == "x:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].x = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "hp:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].hp = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "times:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].times = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "reserve:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].reserve = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "join:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].join = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "join_reserve:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].join_reserve = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "act:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].act = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "ratio:"){
                                    if(CurrentSpawn >= 60) continue;

                                    File >> Buffer;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].ratio = strtod(Buffer.c_str(),&EndPos);
                                }else if(Buffer == "<soldier>"){
                                    if(CurrentSpawn >= 60) continue;

                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].role = 1;
                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].times = 50;
                                }else if(Buffer == "<boss>"){
                                    if(CurrentSpawn >= 60) continue;

                                    Stage[Id].phases[Stage[Id].phase_count].spawns[CurrentSpawn].role = 2;
                                }else if(Buffer == "<stage>"){
                                    SkipReadBuffer = true;
                                    break;
                                }

                                if(errno != 0 || EndPos == Buffer.c_str()){
                                    free(Stage);
                                    CloseHandle(Proc);
                                    return;
                                }
                            }
                        }else if(Buffer == "<stage>"){
                            SkipReadBuffer = true;
                            break;
                        }

                        if(errno != 0 || EndPos == Buffer.c_str()){
                            free(Stage);
                            CloseHandle(Proc);
                            return;
                        }
                    }

                    ++Stage[Id].phase_count;
                }
            }

            if(WriteProcessMemory(Proc,Addr,Stage,sizeof(sStage)*60,NULL) == 0){
                CloseHandle(Proc);
                return;
            }

            free(Stage);
        }else{
            if(ReadProcessMemory(Proc,Addr,&Addr,4,NULL) == 0){//dereference Addr
                CloseHandle(Proc);
                return;
            }

            sDataFile RDataFile;

            if(ReadProcessMemory(Proc,Addr,&RDataFile,sizeof(sDataFile),NULL) == 0){
                CloseHandle(Proc);
                return;
            }

            sDataFile DataFile = {0};

            DataFile.unkwn1 = RDataFile.unkwn1;
            DataFile.unkwn3 = RDataFile.unkwn3;
            DataFile.unkwn4 = RDataFile.unkwn4;
            memcpy(DataFile.unkwn2,RDataFile.unkwn2,sizeof(sDataFile::unkwn2));
            memcpy(DataFile.unkwn5,RDataFile.unkwn5,sizeof(sDataFile::unkwn5));

            DataFile.pic_count = RDataFile.pic_count;
            memcpy(DataFile.pic_bmps,RDataFile.pic_bmps,sizeof(sDataFile::pic_bmps));
            memcpy(DataFile.pic_index,RDataFile.pic_index,sizeof(sDataFile::pic_index));
            memcpy(DataFile.pic_width,RDataFile.pic_width,sizeof(sDataFile::pic_width));
            memcpy(DataFile.pic_height,RDataFile.pic_height,sizeof(sDataFile::pic_height));
            memcpy(DataFile.pic_row,RDataFile.pic_row,sizeof(sDataFile::pic_row));
            memcpy(DataFile.pic_col,RDataFile.pic_col,sizeof(sDataFile::pic_col));
            memcpy(DataFile.small_bmp,RDataFile.small_bmp,sizeof(sDataFile::pic_bmps));
            memcpy(DataFile.face_bmp,RDataFile.face_bmp,sizeof(sDataFile::pic_bmps));

            DataFile.id = Id;
            DataFile.type = Type;

            for(int i = 0;i<400;++i){
                DataFile.frames[i].sound = RDataFile.frames[i].sound;

                DataFile.frames[i].unkwn1 = RDataFile.frames[i].unkwn1;
                DataFile.frames[i].unkwn2 = RDataFile.frames[i].unkwn2;
                DataFile.frames[i].unkwn3 = RDataFile.frames[i].unkwn3;
                DataFile.frames[i].unkwn4 = RDataFile.frames[i].unkwn4;
                DataFile.frames[i].unkwn5 = RDataFile.frames[i].unkwn5;
                DataFile.frames[i].unkwn6 = RDataFile.frames[i].unkwn6;
                DataFile.frames[i].unkwn7 = RDataFile.frames[i].unkwn7;
                DataFile.frames[i].unkwn8 = RDataFile.frames[i].unkwn8;
                DataFile.frames[i].unkwn9 = RDataFile.frames[i].unkwn9;
                DataFile.frames[i].unkwn10 = RDataFile.frames[i].unkwn10;
                DataFile.frames[i].unkwn11 = RDataFile.frames[i].unkwn11;
                DataFile.frames[i].unkwn12 = RDataFile.frames[i].unkwn12;
                DataFile.frames[i].unkwn13 = RDataFile.frames[i].unkwn13;
                DataFile.frames[i].unkwn14 = RDataFile.frames[i].unkwn14;
                DataFile.frames[i].unkwn15 = RDataFile.frames[i].unkwn15;
                DataFile.frames[i].unkwn16 = RDataFile.frames[i].unkwn16;
                DataFile.frames[i].unkwn17 = RDataFile.frames[i].unkwn17;
                DataFile.frames[i].unkwn18 = RDataFile.frames[i].unkwn18;
                DataFile.frames[i].unkwn19 = RDataFile.frames[i].unkwn19;
            }

            stringstream File;
            File.str((const char*)CurrentPanel->Editor->GetText().mb_str());

            string Buffer;

            sItr Itrs[400][5] = {{{0}}};
            sBdy Bdys[400][5] = {{{0}}};

            while(!File.eof()){
                File >> Buffer;
                if(Buffer == "<bmp_begin>"){
                    while(Buffer != "<bmp_end>" && !File.eof()){
                        File >> Buffer;

                        errno = 0;
                        char *EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                        if(Buffer.substr(0,4) == "file"){//we will simply skip this, as it isn't our job to handle images (it's a data changer)
                            File >> Buffer //string
                                 >> Buffer //w:
                                 >> Buffer //number
                                 >> Buffer //h:
                                 >> Buffer //number
                                 >> Buffer //row:
                                 >> Buffer //number
                                 >> Buffer //col:
                                 >> Buffer;//number
                        }else if(Buffer == "name:"){
                            File >> Buffer;
                            strcpy(DataFile.name,Buffer.c_str());
                        }else if(Buffer == "head:"){//again not our job to handle images
                            File >> Buffer;
                        }else if(Buffer == "small:"){//again not our job to handle images
                            File >> Buffer;
                        }else if(Buffer == "walking_frame_rate"){
                            File >> Buffer;
                            DataFile.walking_frame_rate = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "walking_speed"){
                            File >> Buffer;
                            DataFile.walking_speed = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "walking_speedz"){
                            File >> Buffer;
                            DataFile.walking_speedz = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "running_frame_rate"){
                            File >> Buffer;
                            DataFile.running_frame_rate = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "running_speed"){
                            File >> Buffer;
                            DataFile.running_speed = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "running_speedz"){
                            File >> Buffer;
                            DataFile.running_speedz = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "heavy_walking_speed"){
                            File >> Buffer;
                            DataFile.heavy_walking_speed = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "heavy_walking_speedz"){
                            File >> Buffer;
                            DataFile.heavy_walking_speedz = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "heavy_running_speed"){
                            File >> Buffer;
                            DataFile.heavy_running_speed = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "heavy_running_speedz"){
                            File >> Buffer;
                            DataFile.heavy_running_speedz = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "jump_height"){
                            File >> Buffer;
                            DataFile.jump_height = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "jump_distance"){
                            File >> Buffer;
                            DataFile.jump_distance = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "jump_distancez"){
                            File >> Buffer;
                            DataFile.jump_distancez = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "dash_height"){
                            File >> Buffer;
                            DataFile.dash_height = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "dash_distance"){
                            File >> Buffer;
                            DataFile.dash_distance = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "dash_distancez"){
                            File >> Buffer;
                            DataFile.dash_distancez = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "rowing_height"){
                            File >> Buffer;
                            DataFile.rowing_height = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "rowing_distance"){
                            File >> Buffer;
                            DataFile.rowing_distance = strtod(Buffer.c_str(),&EndPos);
                        }else if(Buffer == "weapon_hit_sound"){//we don't care, sound isn't our job either
                            File >> Buffer;
                        }else if(Buffer == "weapon_drop_sound"){//still don't care
                            File >> Buffer;
                        }else if(Buffer == "weapon_broken_sound"){//nope, not this time either
                            File >> Buffer;
                        }else if(Buffer == "weapon_hp"){
                            File >> Buffer;
                            DataFile.weapon_hp = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "weapon_drop_hurt"){
                            File >> Buffer;
                            DataFile.weapon_drop_hurt = strtol(Buffer.c_str(),&EndPos,10);
                        }

                        if(errno != 0 || EndPos == Buffer.c_str()){
                            CloseHandle(Proc);
                            return;
                        }
                    }
                }else if(Buffer == "<frame>"){
                    int FrameNum;
                    File >> FrameNum;
                    if(FrameNum<0 || FrameNum >= 400) continue;

                    DataFile.frames[FrameNum].exists = 1;

                    File >> Buffer;

                    strcpy(DataFile.frames[FrameNum].fname,Buffer.c_str());

                    while(Buffer != "<frame_end>" && !File.eof()){
                        File >> Buffer;

                        errno = 0;
                        char *EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                        if(Buffer == "pic:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].pic = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "state:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].state = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "wait:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].wait = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "next:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].next = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "dvx:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].dvx = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "dvy:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].dvy = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "dvz:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].dvz = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_a:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_a = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_d:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_d = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_j:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_j = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_Fa:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_Fa = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_Ua:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_Ua = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_Da:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_Da = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_Fj:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_Fj = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_Uj:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_Uj = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_Dj:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_Dj = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "hit_ja:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].hit_ja = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "mp:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].mp = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "centerx:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].centerx = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "centery:"){
                            File >> Buffer;
                            DataFile.frames[FrameNum].centery = strtol(Buffer.c_str(),&EndPos,10);
                        }else if(Buffer == "opoint:"){
                            while(Buffer != "opoint_end:" && !File.eof()){
                                File >> Buffer;

                                errno = 0;
                                EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                                if(Buffer == "kind:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.kind = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "x:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.x = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "y:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.y = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "action:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.action = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dvx:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.dvx = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dvy:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.dvy = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "oid:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.oid = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "facing:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].opoint.facing = strtol(Buffer.c_str(),&EndPos,10);
                                }

                                if(errno != 0 || EndPos == Buffer.c_str()){
                                    CloseHandle(Proc);
                                    return;
                                }
                            }
                        }else if(Buffer == "bpoint:"){
                            while(Buffer != "bpoint_end:" && !File.eof()){
                                File >> Buffer;

                                errno = 0;
                                EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                                if(Buffer == "x:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].bpoint.x = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "y:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].bpoint.y = strtol(Buffer.c_str(),&EndPos,10);
                                }

                                if(errno != 0 || EndPos == Buffer.c_str()){
                                    CloseHandle(Proc);
                                    return;
                                }
                            }
                        }else if(Buffer == "cpoint:"){
                            while(Buffer != "cpoint_end:" && !File.eof()){
                                File >> Buffer;

                                errno = 0;
                                EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                                if(Buffer == "kind:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.kind = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "x:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.x = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "y:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.y = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "injury:" || Buffer == "fronthurtact:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.injury = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "cover:" || Buffer == "backhurtact:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.cover = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "vaction:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.vaction = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "aaction:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.aaction = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "jaction:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.jaction = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "daction:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.daction = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "throwvx:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.throwvx = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "throwvy:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.throwvy = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "hurtable:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.hurtable = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "decrease:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.decrease = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dircontrol:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.dircontrol = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "taction:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.taction = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "throwinjury:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.throwinjury = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "throwvz:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].cpoint.throwvz = strtol(Buffer.c_str(),&EndPos,10);
                                }

                                if(errno != 0 || EndPos == Buffer.c_str()){
                                    CloseHandle(Proc);
                                    return;
                                }
                            }
                        }else if(Buffer == "wpoint:"){
                            while(Buffer != "wpoint_end:" && !File.eof()){
                                File >> Buffer;

                                errno = 0;
                                EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                                if(Buffer == "kind:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.kind = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "x:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.x = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "y:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.y = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "weaponact:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.weaponact = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "attacking:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.attacking = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "cover:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.cover = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dvx:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.dvx = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dvy:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.dvy = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dvz:"){
                                    File >> Buffer;
                                    DataFile.frames[FrameNum].wpoint.dvz = strtol(Buffer.c_str(),&EndPos,10);
                                }

                                if(errno != 0 || EndPos == Buffer.c_str()){
                                    CloseHandle(Proc);
                                    return;
                                }
                            }
                        }else if(Buffer == "itr:" && DataFile.frames[FrameNum].itr_count<5){
                            while(Buffer != "itr_end:" && !File.eof()){
                                File >> Buffer;

                                errno = 0;
                                EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                                if(Buffer == "kind:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].kind = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "x:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].x = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "y:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].y = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "w:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].w = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "h:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].h = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dvx:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].dvx = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "dvy:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].dvy = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "fall:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].fall = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "arest:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].arest = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "vrest:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].vrest = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "effect:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].effect = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "bdefend:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].bdefend = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "injury:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].injury = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "zwidth:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].zwidth = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "catchingact:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].catchingact1 = strtol(Buffer.c_str(),&EndPos,10);

                                    if(errno != 0 || EndPos == Buffer.c_str()){
                                        CloseHandle(Proc);
                                        return;
                                    }

                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].catchingact2 = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "caughtact:"){
                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].caughtact1 = strtol(Buffer.c_str(),&EndPos,10);

                                    if(errno != 0 || EndPos == Buffer.c_str()){
                                        CloseHandle(Proc);
                                        return;
                                    }

                                    File >> Buffer;
                                    Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].caughtact2 = strtol(Buffer.c_str(),&EndPos,10);
                                }

                                if(errno != 0 || EndPos == Buffer.c_str()){
                                    CloseHandle(Proc);
                                    return;
                                }
                            }

                            const int x = Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].x,
                                      y = Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].y,
                                      w = Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].w,
                                      h = Itrs[FrameNum][DataFile.frames[FrameNum].itr_count].h;

                            if(DataFile.frames[FrameNum].itr_count == 0){//is this the first itr in the frame
                                DataFile.frames[FrameNum].itr_x = x;
                                DataFile.frames[FrameNum].itr_y = y;
                                DataFile.frames[FrameNum].itr_w = w;
                                DataFile.frames[FrameNum].itr_h = h;

                                if(RDataFile.frames[FrameNum].itr_count == 0){//should we allocate or simply use previously allocated memory
                                    sItr *ItrAlloc = (sItr*)VirtualAllocEx(Proc,NULL,sizeof(sItr)*5,MEM_COMMIT,PAGE_READWRITE);//allocate itrs for LF2

                                    if(!ItrAlloc){
                                        CloseHandle(Proc);
                                        return;
                                    }

                                    DataFile.frames[FrameNum].itrs = ItrAlloc;
                                }else{
                                    DataFile.frames[FrameNum].itrs = RDataFile.frames[FrameNum].itrs;
                                }
                            }else{//if this isn't the first we are going to do some complex math
                                if(x<DataFile.frames[FrameNum].itr_x){
                                    DataFile.frames[FrameNum].itr_w += DataFile.frames[FrameNum].itr_x-x;
                                    DataFile.frames[FrameNum].itr_x = x;
                                }
                                if(y<DataFile.frames[FrameNum].itr_y){
                                    DataFile.frames[FrameNum].itr_h += DataFile.frames[FrameNum].itr_h-h;
                                    DataFile.frames[FrameNum].itr_y = y;
                                }
                                if(w>DataFile.frames[FrameNum].itr_w){
                                    DataFile.frames[FrameNum].itr_w = w;
                                }
                                if(h>DataFile.frames[FrameNum].itr_h){
                                    DataFile.frames[FrameNum].itr_h = h;
                                }
                            }

                            ++DataFile.frames[FrameNum].itr_count;
                        }else if(Buffer == "bdy:" && DataFile.frames[FrameNum].bdy_count<5){
                            while(Buffer != "bdy_end:" && !File.eof()){
                                File >> Buffer;

                                errno = 0;
                                EndPos = NULL;//used to check if the value was retrieved correctly (as in converted from string to integer)

                                if(Buffer == "kind:"){
                                    File >> Buffer;
                                    Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].kind = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "x:"){
                                    File >> Buffer;
                                    Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].x = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "y:"){
                                    File >> Buffer;
                                    Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].y = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "w:"){
                                    File >> Buffer;
                                    Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].w = strtol(Buffer.c_str(),&EndPos,10);
                                }else if(Buffer == "h:"){
                                    File >> Buffer;
                                    Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].h = strtol(Buffer.c_str(),&EndPos,10);
                                }

                                if(errno != 0 || EndPos == Buffer.c_str()){
                                    CloseHandle(Proc);
                                    return;
                                }
                            }

                            const int x = Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].x,
                                      y = Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].y,
                                      w = Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].w,
                                      h = Bdys[FrameNum][DataFile.frames[FrameNum].bdy_count].h;

                            if(DataFile.frames[FrameNum].bdy_count == 0){//is this the first bdy in the frame
                                DataFile.frames[FrameNum].bdy_x = x;
                                DataFile.frames[FrameNum].bdy_y = y;
                                DataFile.frames[FrameNum].bdy_w = w;
                                DataFile.frames[FrameNum].bdy_h = h;

                                if(RDataFile.frames[FrameNum].bdy_count == 0){//should we allocate or simply use previously allocated memory
                                    sBdy *BdyAlloc = (sBdy*)VirtualAllocEx(Proc,NULL,sizeof(sBdy)*5,MEM_COMMIT,PAGE_READWRITE);//allocate bdys for LF2

                                    if(!BdyAlloc){
                                        CloseHandle(Proc);
                                        return;
                                    }

                                    DataFile.frames[FrameNum].bdys = BdyAlloc;
                                }else{
                                    DataFile.frames[FrameNum].bdys = RDataFile.frames[FrameNum].bdys;
                                }
                            }else{//if this isn't the first we are going to do some complex math
                                if(x<DataFile.frames[FrameNum].bdy_x){
                                    DataFile.frames[FrameNum].bdy_w += DataFile.frames[FrameNum].bdy_x-x;
                                    DataFile.frames[FrameNum].bdy_x = x;
                                }
                                if(y<DataFile.frames[FrameNum].bdy_y){
                                    DataFile.frames[FrameNum].bdy_h += DataFile.frames[FrameNum].bdy_h-h;
                                    DataFile.frames[FrameNum].bdy_y = y;
                                }
                                if(w>DataFile.frames[FrameNum].bdy_w){
                                    DataFile.frames[FrameNum].bdy_w = w;
                                }
                                if(h>DataFile.frames[FrameNum].bdy_h){
                                    DataFile.frames[FrameNum].bdy_h = h;
                                }
                            }

                            ++DataFile.frames[FrameNum].bdy_count;
                        }

                        if(errno != 0 || EndPos == Buffer.c_str()){
                            CloseHandle(Proc);
                            return;
                        }
                    }
                }
            }


            SYSTEM_INFO SysInfo;
            GetSystemInfo(&SysInfo);//dwPageSize is needed to figure out how big RegionSize will be when we allocate ourself

            unsigned int AllocItrSize = SysInfo.dwPageSize,
                         AllocBdySize = SysInfo.dwPageSize;

            while(AllocItrSize<sizeof(sItr)*5) AllocItrSize += SysInfo.dwPageSize;
            while(AllocBdySize<sizeof(sBdy)*5) AllocBdySize += SysInfo.dwPageSize;

            for(unsigned int i = 0;i<400;++i){
                if(RDataFile.frames[i].itr_count>0 && DataFile.frames[i].itr_count == 0){//deallocate itrs
                    MEMORY_BASIC_INFORMATION MemInfo;
                    if(VirtualQueryEx(Proc,RDataFile.frames[i].itrs,&MemInfo,sizeof(MemInfo)) == 0){
                        CloseHandle(Proc);
                        return;
                    }

                    if(MemInfo.RegionSize == AllocItrSize){
                        if(VirtualFreeEx(Proc,RDataFile.frames[i].itrs,0,MEM_RELEASE) == 0){
                            CloseHandle(Proc);
                            return;
                        }
                    }
                }
                if(RDataFile.frames[i].bdy_count>0 && DataFile.frames[i].bdy_count == 0){//deallocate bdys
                    MEMORY_BASIC_INFORMATION MemInfo;
                    if(VirtualQueryEx(Proc,RDataFile.frames[i].bdys,&MemInfo,sizeof(MemInfo)) == 0){
                        CloseHandle(Proc);
                        return;
                    }

                    if(MemInfo.RegionSize == AllocBdySize){
                        if(VirtualFreeEx(Proc,RDataFile.frames[i].bdys,0,MEM_RELEASE) == 0){
                            CloseHandle(Proc);
                            return;
                        }
                    }
                }

                if(DataFile.frames[i].itr_count>0){
                    if(WriteProcessMemory(Proc,DataFile.frames[i].itrs,Itrs[i],sizeof(sItr)*5,NULL) == 0){
                        CloseHandle(Proc);
                        return;
                    }
                }

                if(DataFile.frames[i].bdy_count>0){
                    if(WriteProcessMemory(Proc,DataFile.frames[i].bdys,Bdys[i],sizeof(sBdy)*5,NULL) == 0){
                        CloseHandle(Proc);
                        return;
                    }
                }

                if(WriteProcessMemory(Proc,Addr,&DataFile,sizeof(sDataFile),NULL) == 0){
                    CloseHandle(Proc);
                    return;
                }
            }
        }

        CloseHandle(Proc);
    }

    BOOL CALLBACK LF2DataChangerFrame::EnumWindowsProcAll(HWND Window,LPARAM Param){
        char ClassName[80];
        GetClassNameA(Window,ClassName,sizeof(ClassName));

        if(strcmp("Marti",ClassName) != 0) return TRUE;

        unsigned long Pid;

        GetWindowThreadProcessId(Window,&Pid);

        HANDLE Proc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,Pid);

        if(Proc == INVALID_HANDLE_VALUE) return FALSE;

        {//State is only needed temporarily, so we put it in another scope
            int State;
            if(ReadProcessMemory(Proc,(void*)0x458B00,&State,4,NULL) == 0){
                CloseHandle(Proc);
                return FALSE;
            }

            if(State != 2){//LF2 hasn't loaded datafiles
                CloseHandle(Proc);
                return TRUE;
            }
        }

        CloseHandle(Proc);

        ((vector<HWND>*)Param)->push_back(Window);

        return TRUE;
    }

    BOOL CALLBACK LF2DataChangerFrame::EnumWindowsProcAdv(HWND Window,LPARAM Param){
        if(((DFStruct*)Param)->Pid != -1) return TRUE;

        char ClassName[80];
        GetClassNameA(Window,ClassName,sizeof(ClassName));

        if(strcmp("Marti",ClassName) != 0) return TRUE;

        unsigned long Pid;

        GetWindowThreadProcessId(Window,&Pid);

        HANDLE Proc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,Pid);

        if(Proc == INVALID_HANDLE_VALUE) return FALSE;

        {//State is only needed temporarily, so we put it in another scope
            int State;
            if(ReadProcessMemory(Proc,(void*)0x458B00,&State,4,NULL) == 0){
                CloseHandle(Proc);
                return FALSE;
            }

            if(State != 2){//LF2 hasn't loaded datafiles
                CloseHandle(Proc);
                return TRUE;
            }
        }

        char DataPath[0x10];//0x10 is the maximal length of the path to data.txt and stage.dat
        wchar_t DataPathW[sizeof(DataPath)];
        wchar_t Filename[MAX_PATH];

        if(GetModuleFileNameEx(Proc,NULL,Filename,MAX_PATH) == 0){
            CloseHandle(Proc);
            return TRUE;
        }

        wchar_t *FN = wcsrchr(Filename,'\\')+1;

        if(ReadProcessMemory(Proc,(void*)0x447be0,DataPath,sizeof(DataPath)-1,NULL) == 0){//read stage.dat location
            CloseHandle(Proc);
            return TRUE;
        }

        DataPath[sizeof(DataPath)-1] = '\0';//add a null terminator at the end
        mbstowcs(DataPathW,DataPath,sizeof(DataPath));

        wcscpy(FN,DataPathW);//make Filename the full path to stage.dat

        if(wcsicmp(CurrentFilename,Filename) == 0){
            ((DFStruct*)Param)->Window = Window;
            ((DFStruct*)Param)->Pid = Pid;
            ((DFStruct*)Param)->Id = -1;
            ((DFStruct*)Param)->Type = -1;
            ((DFStruct*)Param)->Addr = (char*)offsetof(sFileManager,stages);

            CloseHandle(Proc);
            return TRUE;
        }

        if(ReadProcessMemory(Proc,(void*)0x448980,DataPath,sizeof(DataPath)-1,NULL) == 0){//read data.txt location
            CloseHandle(Proc);
            return TRUE;
        }

        CloseHandle(Proc);

        DataPath[sizeof(DataPath)-1] = '\0';//add a null terminator at the end
        mbstowcs(DataPathW,DataPath,sizeof(DataPath));

        wcscpy(FN,DataPathW);//make Filename the full path to data.txt

        FILE *File = _wfopen(Filename,_T("r"));//open data.txt

        if(!File) return FALSE;

        int Id = 0;
        int Type;
        char Buffer[MAX_PATH];
        char *Addr = offsetof(sFileManager,datas);
        char *BgrOffset = (char*)offsetof(sFileManager,backgrounds);
        bool WaitingForId = true;

        while(!feof(File)){
            fgetword(Buffer,sizeof(Buffer),File);
            if(strcmp(Buffer,"id:") == 0){
                fgetword(Buffer,sizeof(Buffer),File);
                Id = atoi(Buffer);
                Type = -1;

                WaitingForId = false;
            }else if(strcmp(Buffer,"type:") == 0){
                if(Addr<BgrOffset){
                    fgetword(Buffer,sizeof(Buffer),File);
                    Type = atoi(Buffer);
                }
            }else if(strcmp(Buffer,"file:") == 0){
                if(WaitingForId || (Type == -1 && Addr<BgrOffset)) continue;

                wchar_t BufferW[sizeof(Buffer)];

                fgetword(Buffer,sizeof(Buffer),File);

                mbstowcs(BufferW,Buffer,sizeof(Buffer));

                wcscpy(FN,BufferW);

                if(wcsicmp(CurrentFilename,Filename) == 0){
                    ((DFStruct*)Param)->Window = Window;
                    ((DFStruct*)Param)->Pid = Pid;
                    ((DFStruct*)Param)->Id = Id;
                    ((DFStruct*)Param)->Type = Type;
                    ((DFStruct*)Param)->Addr = Addr;
                    break;
                }

                if(Addr >= BgrOffset){
                    Addr += sizeof(sBackground);
                }else{
                    Addr += 4;
                }

                WaitingForId = true;
            }else if(strcmp(Buffer,"<background>") == 0){
                Addr = BgrOffset;
            }
        }

        fclose(File);//close data.txt

        return TRUE;
    }

    bool LF2DataChangerFrame::PauseResumeThreadList(unsigned int dwOwnerPID,bool bResumeThread){//original code written by Daniel Turini from the code project, slightly modified by Someone else
        HANDLE        hThreadSnap = NULL;
        bool          bRet        = false;
        THREADENTRY32 te32        = {0};

        hThreadSnap = CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD,0);
        if(hThreadSnap == INVALID_HANDLE_VALUE) return false;

        te32.dwSize = sizeof(THREADENTRY32);

        if(Thread32First(hThreadSnap,&te32)){
            do {
                if(te32.th32OwnerProcessID == dwOwnerPID){
                    HANDLE hThread = OpenThread(THREAD_SUSPEND_RESUME,false,te32.th32ThreadID);
                    if(bResumeThread){
                        ResumeThread(hThread);
                    }else{
                        SuspendThread(hThread);
                    }
                    CloseHandle(hThread);
                }
            }
            while(Thread32Next(hThreadSnap,&te32));
            bRet = true;
        }else bRet = false;

        CloseHandle(hThreadSnap);

        return bRet;
    }
#endif

void LF2DataChangerFrame::OnAutoWrite(wxCommandEvent& event){
    if(event.GetId() != ID_MENUWRITEAUTO){
        MenuWriteAuto->Toggle();
    }

    AuiToolBarWrite->SetToolSticky(ID_AUITOOLBARWRITEAUTO,MenuWriteAuto->IsChecked());
}

void LF2DataChangerFrame::OnTabRightUp(wxAuiNotebookEvent& event){
    int ID = AuiNotebook->GetPage(AuiNotebook->GetSelection())->GetId();
    AuiNotebook->SetSelection(event.GetSelection());

    TabSave->Enable(MenuFileSave->IsEnabled());

    PopupMenu(&TabMenu);

    for(unsigned int i = 0;i<AuiNotebook->GetPageCount();++i){
        if(AuiNotebook->GetPage(i)->GetId() == ID){
            AuiNotebook->SetSelection(i);
            return;
        }
    }
}
