/***************************************************************
   LF2 Data Changer is a program that a allows you to edit, LF2 data files.
    Copyright (C) 2012  Someone else

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

My email address is <adrianbibbywalther@gmail.com>.
If you need any help, contact me there, or on the LFE Forums.
 **************************************************************/

#include "WriteToDialog.h"

//(*InternalHeaders(WriteToDialog)
#include <wx/intl.h>
#include <wx/button.h>
#include <wx/string.h>
//*)

#include "sGame.h"
#include <fstream>

#include <psapi.h>

#include "fgetword.h"

//(*IdInit(WriteToDialog)
const long WriteToDialog::ID_CHOOSEIDTEXT = wxNewId();
const long WriteToDialog::ID_CHOOSEID = wxNewId();
//*)

BEGIN_EVENT_TABLE(WriteToDialog,wxDialog)
	//(*EventTable(WriteToDialog)
	//*)
END_EVENT_TABLE()

WriteToDialog::WriteToDialog(wxWindow* parent,wxWindowID id)
{
	//(*Initialize(WriteToDialog)
	wxFlexGridSizer* Sizer;
	wxStdDialogButtonSizer* Buttons;
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, wxID_ANY, _("Write to executable"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE, _T("wxID_ANY"));
	Sizer = new wxFlexGridSizer(0, 1, 0, 0);
	FlexGridSizer1 = new wxFlexGridSizer(0, 2, 0, 0);
	ChooseIdText = new wxStaticText(this, ID_CHOOSEIDTEXT, _("ID:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_CHOOSEIDTEXT"));
	FlexGridSizer1->Add(ChooseIdText, 1, wxALL|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	ChooseId = new wxChoice(this, ID_CHOOSEID, wxDefaultPosition, wxDefaultSize, 0, 0, 0, wxDefaultValidator, _T("ID_CHOOSEID"));
	FlexGridSizer1->Add(ChooseId, 1, wxTOP|wxBOTTOM|wxRIGHT|wxEXPAND|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	Sizer->Add(FlexGridSizer1, 1, wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Buttons = new wxStdDialogButtonSizer();
	Buttons->AddButton(new wxButton(this, wxID_OK, wxEmptyString));
	Buttons->AddButton(new wxButton(this, wxID_CANCEL, wxEmptyString));
	Buttons->Realize();
	Sizer->Add(Buttons, 1, wxTOP|wxBOTTOM|wxALIGN_LEFT|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(Sizer);
	Sizer->Fit(this);
	Sizer->SetSizeHints(this);

	Connect(ID_CHOOSEID,wxEVT_COMMAND_CHOICE_SELECTED,(wxObjectEventFunction)&WriteToDialog::OnChoice);
	//*)
}

WriteToDialog::~WriteToDialog()
{
	//(*Destroy(WriteToDialog)
	//*)
}

#include <iostream>
using namespace std;

bool WriteToDialog::Prepare(EditorPanel *Panel){
    Pid = Panel->Pid;
    Id = 0;
    Type = 0;
    Addr = NULL;

    FindItem(wxID_OK)->Disable();
    ChooseId->Clear();

    Ids.clear();

    HANDLE Proc = OpenProcess(PROCESS_ALL_ACCESS,FALSE,Pid);

    if(Proc == INVALID_HANDLE_VALUE) return false;

    char DataPath[0x10];//0x10 is the maximal length of the path to data.txt and stage.dat
    wchar_t DataPathW[sizeof(DataPath)];
    wchar_t Filename[MAX_PATH];

    if(GetModuleFileNameEx(Proc,NULL,Filename,MAX_PATH) == 0){
        CloseHandle(Proc);
        return false;
    }

    if(ReadProcessMemory(Proc,(void*)0x447be0,DataPath,sizeof(DataPath)-1,NULL) == 0){//read stage.dat location
        CloseHandle(Proc);
        return false;
    }

    IdStruct Struct = {-1,-1,(char*)offsetof(sFileManager,stages)};
    Ids.push_back(Struct);

    ChooseId->Append(wxString::From8BitData(DataPath));

    if(ReadProcessMemory(Proc,(void*)0x448980,DataPath,sizeof(DataPath)-1,NULL) == 0){
        CloseHandle(Proc);
        return false;
    }
    CloseHandle(Proc);

    mbstowcs(DataPathW,DataPath,sizeof(DataPath));

    wcscpy(wcsrchr(Filename,'\\')+1,DataPathW);//make Filename the full path to data.txt

    FILE *File = _wfopen(Filename,_T("r"));//open data.txt

    if(!File) return false;

    int Id;
    int Type;
    char Buffer[MAX_PATH];
    char *Addr = offsetof(sFileManager,datas);
    char *BgrOffset = (char*)offsetof(sFileManager,backgrounds);
    bool WaitingForId = true;

    while(!feof(File)){
        fgetword(Buffer,sizeof(Buffer),File);
        if(strcmp(Buffer,"id:") == 0){
            fgetword(Buffer,sizeof(Buffer),File);
            Id = atoi(Buffer);
            Type = -1;

            WaitingForId = false;
        }else if(strcmp(Buffer,"type:") == 0){
            if(Addr<BgrOffset){
                fgetword(Buffer,sizeof(Buffer),File);
                Type = atoi(Buffer);
            }
        }else if(strcmp(Buffer,"file:") == 0){
            if(WaitingForId) continue;

            fgetword(Buffer,sizeof(Buffer),File);

            IdStruct Struct = {Id,Type,Addr};
            Ids.push_back(Struct);

            wxString String;
            String << Id << _T("-") << wxString::From8BitData(Buffer);

            ChooseId->Append(String);

            if(Panel->Addr == Addr){
                ChooseId->SetSelection(ChooseId->GetCount()-1);
                FindItem(wxID_OK)->Enable();
            }

            if(Addr >= BgrOffset){
                Addr += sizeof(sBackground);
            }else{
                Addr += 4;
            }

            WaitingForId = true;
        }else if(strcmp(Buffer,"<background>") == 0){
            Addr = BgrOffset;
        }
    }

    fclose(File);//close data.txt
    return true;
}

void WriteToDialog::OnChoice(wxCommandEvent& event){
    IdStruct &Struct = Ids[ChooseId->GetSelection()];

    Id = Struct.Id;
    Type = Struct.Type;
    Addr = Struct.Addr;

    FindItem(wxID_OK)->Enable();
}
